/**
 * (The MIT License)
 * Copyright (c) 2011 hij1nx http://www.twitter.com/hij1nx
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * See https://github.com/hij1nx/EventEmitter2
 */

define("utils/ConvertUtils",["jquery","underscore"],function(g){return{getLangFormattedDate:function(c,g){var a=[];a[0]=c.t("MONTH1");a[1]=c.t("MONTH2");a[2]=c.t("MONTH3");a[3]=c.t("MONTH4");a[4]=c.t("MONTH5");a[5]=c.t("MONTH6");a[6]=c.t("MONTH7");a[7]=c.t("MONTH8");a[8]=c.t("MONTH9");a[9]=c.t("MONTH10");a[10]=c.t("MONTH11");a[11]=c.t("MONTH12");null==g&&(g=new Date);var h=g.getMonth(),k=g.getDate(),e=g.getFullYear();return""+a[h]+" "+k+", "+e},getLangFormattedDateAndTime:function(c,g){var a=[];a[0]=
c.t("MONTH1");a[1]=c.t("MONTH2");a[2]=c.t("MONTH3");a[3]=c.t("MONTH4");a[4]=c.t("MONTH5");a[5]=c.t("MONTH6");a[6]=c.t("MONTH7");a[7]=c.t("MONTH8");a[8]=c.t("MONTH9");a[9]=c.t("MONTH10");a[10]=c.t("MONTH11");a[11]=c.t("MONTH12");null==g&&(g=new Date);var h=g.getMonth(),k=g.getDate(),e=g.getFullYear(),b=g.getHours();10>b&&(b="0"+b);var d=g.getMinutes();10>d&&(d="0"+d);return c.t("DateAndTimeString",a[h],k,e,b,d)},getEnglishFormattedDate:function(c,j){var a={};a[c.t("MONTH1")]="Jan";a[c.t("MONTH2")]=
"Feb";a[c.t("MONTH3")]="Mar";a[c.t("MONTH4")]="Apr";a[c.t("MONTH5")]="May";a[c.t("MONTH6")]="Jun";a[c.t("MONTH7")]="Jul";a[c.t("MONTH8")]="Aug";a[c.t("MONTH9")]="Sep";a[c.t("MONTH10")]="Oct";a[c.t("MONTH11")]="Nov";a[c.t("MONTH12")]="Dec";var h=g.trim(j).split(" ");return a[h[0]]?(h[0]=a[h[0]],h.join("")):j},capitaliseFirstLetter:function(c){return c.charAt(0).toUpperCase()+c.slice(1)},getCharacterLineCount:function(c){var g=1,a=0;if(c){for(var c=this.convertHTMLStringToRaw(c),c=c.replace(/\r\n/g,
"\n"),a=0,h=c.indexOf("\n",0);-1!=h;)g++,a++,h=c.indexOf("\n",h+1);a=c.length-a}return{lineCount:g,charCount:a}},convertHTMLStringToRaw:function(c,g){void 0===g&&(g="\n");var a=c.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,">$1<"),a=a.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,
"$1"),a=a.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),a=a.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,g),a=a.replace(/<[^>]*>/g,""),a=a.replace(/&nbsp;|&#160;/gi," ");return a=this.decodeHtmlEntities(a)},convertRawStringToHTML:function(c){c=this.encodeHtmlEntities(c);return c=c.replace(/(\r)?\n/g,
"<br />")},decodeHtmlEntities:function(c){return g("<textarea>").html(c).text()},encodeHtmlEntities:function(c){return g("<div>").text(c).html()}}});
define("utils/HTTPUtils",["jquery","underscore","utils/ConvertUtils"],function(g,c,j){return{constructURL:function(a,h,k){var e="";k&&(e+=k);var e=e+a,a="?",b;for(b in h){if(h.hasOwnProperty(b))if(c.isArray(h[b]))for(k=0;k<h[b].length;k++)e+=a+encodeURIComponent(b)+"="+encodeURIComponent(j.decodeHtmlEntities(h[b][k]));else e+=a+encodeURIComponent(b)+"="+encodeURIComponent(j.decodeHtmlEntities(h[b]));a="&"}return e}}});
define("utils/XMLUtils",[],function(){var g=null;return g={attributeValue:function(c,g){var a=c.attributes.getNamedItem(g);return a?a.nodeValue:null},nodeTextContent:function(c,j){var a=c.getElementsByTagName(j)[0];return a?g.textContent(a):null},textContent:function(c){var g=c.textContent;void 0===g&&(g=c.nodeTypedValue);return g},xml2obj:function(c,g){for(var a={},h=c.childNodes,k=0;k<h.length;k++){var e=h[k],b=e.nodeName;if("#text"!=b){var d=this.numberOfChildren(e),l=void 0,l=0<d?this.xml2obj(e,
d):this.textContent(e);void 0!==a[b]?("[object Array]"!==Object.prototype.toString.call(a[b])&&(e=a[b],a[b]=[],a[b].push(e)),a[b].push(l)):a[b]=l}}if((void 0!==g||0<this.numberOfChildren(c))&&c.attributes){a.attributes={};for(h=0;h<c.attributes.length;h++)a.attributes[c.attributes[h].name]=c.attributes[h].value}return a},numberOfChildren:function(c){var g=0;if(c.childNodes&&0<c.childNodes.length)for(var a=0;a<c.childNodes.length;a++)1==c.childNodes[a].nodeType&&g++;return g}}});
define("utils/I18n",["utils/HTTPUtils","utils/XMLUtils","underscore","jquery"],function(g,c,j,a){var h=function(a,e,b){this._locale=a?a:"en";this._timestamp=b?b:0;this.wcrInstanceUrl=e;this.bundles={};this.loading={};this.bundleOrder=[];this.bundleLoadedListeners={}};h.prototype.setLocale=function(a){this._locale=a;this.bundles={};for(var a=function(){},e=0;e<this.bundleOrder.length;e++)this.loadBundle(this.bundleOrder[e],a)};h.prototype.getLocale=function(){return this._locale};h.prototype.loadBundle=
function(a,e,b){e&&b&&(e=j.bind(e,b));if(j.isArray(a)){var d=j.after(a.length,j.once(e));j.each(a,j.bind(function(b){this.loadSingleBundle(b,d)},this))}else this.loadSingleBundle(a,e)};h.prototype.loadSingleBundle=function(h,e){if(this.bundles[h])e&&e(this.bundles[h]);else if(e&&this.whenBundleLoaded(h,e),!this.loading[h]){this.bundleOrder.push(h);this.loading[h]=1;var b=this;a.ajax(g.constructURL("DownloadLocKeys.jsp",{scope:h,t:this._timestamp,lk:this._locale},this.wcrInstanceUrl),{dataType:"xml",
success:function(d){if(d){var e=d.getElementsByTagName("code");if(e[0]&&"001"===c.textContent(e[0]))return}for(var e={},d=d.documentElement.getElementsByTagName("lang_string"),a=0;a<d.length;a++){var f=d[a];e[f.getAttribute("key")]=f.getAttribute("value")}b.bundles[h]={};delete b.loading[h];e&&(b.bundles[h]=e);b.fireBundleLoaded(h,b.bundles[h])},error:function(){},cache:!0,type:"GET"})}};h.prototype.whenBundleLoaded=function(a,e){this.bundleLoadedListeners[a]||(this.bundleLoadedListeners[a]=[]);this.bundleLoadedListeners[a].push(e)};
h.prototype.fireBundleLoaded=function(a,e){this.bundleLoadedListeners[a]&&(j.each(this.bundleLoadedListeners[a],function(b){b(e)}),delete this.bundleLoadedListeners[a])};h.prototype.findByKey=function(a){for(var e=this.bundleOrder.length-1;0<=e;e--)if(this.bundles[this.bundleOrder[e]]&&this.bundles[this.bundleOrder[e]][a])return this.bundles[this.bundleOrder[e]][a]};h.prototype.findByKeyInBundle=function(a,e){if(this.bundles[e]&&this.bundles[e][a])return this.bundles[e][a]};h.prototype.t=function(a){var e=
this.findByKey(a);if(void 0!==e){for(var b=1;b<arguments.length;b++)e=e.replace("{"+(b-1)+"}",arguments[b]);return e}return a};h.prototype.d=function(a,e){var b=this.findByKey(a);if(void 0!==b)return e.toString(b)};return h});
define("utils/webi18n",["utils/I18n","jquery"],function(g,c){var j;return j={getInstance:function(){if(!window.webI18n){var a=window,h=function(e,b){void 0===b||null===b||(b instanceof jQuery||(b=c(b)),b.text(e))},k=new g(window.webcenterConfig.userLang,window.webcenterConfig.jspBaseUrl,window.webcenterConfig.languageLoadTimestamp);a.webI18n={loadSingleBundle:function(e,b){k.loadSingleBundle(e,b)},whenBundleLoaded:function(e,b){k.whenBundleLoaded(e,b)},t:function(e,b){var d=k.findByKeyInBundle(e,
b);if(void 0!==d){for(var a=2;a<arguments.length;a++)d=d.replace("{"+(a-2)+"}",arguments[a]);return d}return e},tIn:function(e,b,d){var a=arguments,i=k.findByKeyInBundle(e,b);if(void 0===i)k.whenBundleLoaded(b,function(){i=k.findByKeyInBundle(e,b);if(void 0!==i){for(var f=3;f<a.length;f++)i=i.replace("{"+(f-3)+"}",a[f]);h(i,d)}else h(e,d)}),h(e,d);else{for(var f=3;f<a.length;f++)i=i.replace("{"+(f-3)+"}",a[f]);h(i,d)}},getLocale:function(){return k.getLocale()}}}return window.webI18n},load:function(a,
h,c,e){if(e.isBuild)c();else{var b=j.getInstance();b.loadSingleBundle(a,function(d){c({t:function(d){var e=[d,a].concat(Array.prototype.slice.call(arguments).slice(1));return b.t.apply(b,e)},tFallback:function(d,e){var f=[d,a].concat(Array.prototype.slice.call(arguments).slice(2)),f=b.t.apply(b,f);return f===d?e:f},asMap:function(){return d}})})}}}});
define("doctablex/DocTableXUtils",["jquery","utils/webi18n!DocRefStrings"],function(g,c){var j,a=0;return j={maxBOMCount:2147483647,getNextUniquePrefix:function(){return a++},log:function(a){"undefined"!=typeof console&&console.log(a)},error:function(a){"undefined"!=typeof console?console.error(a):alert(a)},isValidID:function(a){return a&&"string"==typeof a&&16==a.trim().length},getFileExtension:function(a,c){if(null==a||null==a.length||3>a.length||0>a.lastIndexOf(".")||a.lastIndexOf(".")>=a.length-
1)return null;var e=a.substr(a.lastIndexOf(".")),e=e.replace(/^\s+|\s+$/g,"").toLowerCase();c&&(e=e.substring(e.indexOf(".")+1));return e},getRenderItem:function(a,c){if(!a)return null;for(var e=0;e<a.length;e++){var b=a[e];if(b&&b.type){var d=b.type;"DocumentProperty"==d&&(d+="_"+b.typeDetail);if(d==c)return b}}return null},_getFileExtensionsList:function(a){var c=[];if(a&&0<a.length){var e=a.split(",");1==e.length&&(e=a.split(";"));for(a=0;a<e.length;a++){var b=e[a];b&&(b=b.replace(/^\s+|\s+$/g,
"").toLowerCase(),"."==b.substr(0,1)&&(b=b.substr(1)),c.push(b))}}return c},_getDocTemplateNameList:function(a){var c=[];if(a&&0<a.length){var e=a.split(",");1==e.length&&(e=a.split(";"));for(a=0;a<e.length;a++){var b=e[a];b&&(b=b.replace(/^\s+|\s+$/g,"").toLowerCase(),c.push(b))}}return c},preserveFileInputs:function(a){var c=g("#DocTableFileInputsReposElemID");0==c.length&&(c=g('<div id="DocTableFileInputsReposElemID" style="display:none"></div>'),g("body").prepend(c));a=g("#"+a+" input.docTableFileInputToPreserve");
a.appendTo(c);return a.length},reinsertPreservedFileInputs:function(a){g("#DocTableFileInputsReposElemID input.docTableFileInputToPreserve").each(function(e){j.log("Preserved file input"+e+": "+g(this).attr("name"));e=g(this).attr("name");if(!a||0==a.length||0==e.indexOf(a))e=g("input[name="+e+"]").not(this),g(this).attr("name",e.attr("name")),g(this).attr("onchange",e.attr("onchange")),e.replaceWith(g(this))});var c=g("#DocTableFileInputsReposElemID input.docTableFileInputToPreserve");0<c.length&&
!a&&(j.log(c.length+" document(s) to be uploaded was(were) removed from document table(s)!"),c.remove())},getMenuFileParamValue:function(){var a;a="menu_file".replace(/[\[]/,"\\[").replace(/[\]]/,"\\]");a=RegExp("[\\?&]"+a+"=([^&#]*)").exec(location.search);return null===a?"":decodeURIComponent(a[1].replace(/\+/g," "))},getSourcePageURLEncoded:function(){var a=location.pathname.replace(/\/[^\/]*/i,"");return encodeURIComponent(a+location.search)},getEncodedTranslatedLabel:function(a){var g="",e="DocRefColLabel_"+
a;0===a.indexOf("DocRefColLabel_")?g=c.t(a):c.t(e)!=e&&(g=c.t(e));g||(g=a);return WCXML.xmlencode(g)}}});
define("doctablex/DocTableXView",["doctablex/DocTableXUtils","wcr/webcenter_xml","jquery"],function(g,c,j){var a=function(a,c,e){if(!a&&!c&&!e)return this;this.dm=a;this.phElemID=c;this.renderMethodMap={AttributeFlapout:this.renderExpandCollapseButtonHeader,UpDownArrows:this.renderSortingArrowsHeader,SequenceNumber:this.renderSequenceNumberHeader,DocumentName:this.renderDocumentSpecHeader,DocumentActions:this.renderDocumentActionsHeader,DocumentProperty_Thumbnail:this.renderThumbnailHeader,DocumentProperty_Description:this.renderDocumentDescriptionHeader,
DocumentProperty_ApprovalStatus:this.renderApprovalStatusHeader,DocumentProperty_ApprovalStage:this.renderApprovalStageHeader,DocumentProperty_Project:this.renderDocProjectNameHeader,DocumentProperty_VersionRevision:this.renderDocumentVersionHeader,DocumentProperty_VersionAuthor:this.renderDocumentAuthorHeader,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDateHeader,ReferenceProperty:this.renderReferencePropertyHeader,DocumentAttribute:this.renderDocAttributeHeader,LocalRemote:this.renderLocalRemoteButtonHeader,
DeleteButton:this.renderDeleteButtonHeader};this.renderOptions=e;return this};a.prototype.render=function(a){var c=j("#"+this.phElemID);if(0==c.length)return c;this.dm.isInactive&&c.hide();var e=this.renderOptions;a&&(this.renderOptions=a);a=g.preserveFileInputs(this.phElemID);"list"==this.renderOptions.renderMethod?this.renderSimple(c):"table"==this.renderOptions.renderMethod?this.renderComplex(c):alert("Not supported render method: "+this.renderOptions.renderMethod+".");for(var b=0;b<this.dm.docRows.length;b++)this.dm.docRows[b].displayRow(!1);
0<a&&g.reinsertPreservedFileInputs();this.renderDocSourceLinks();this.renderOptions=e;return c};a.prototype.repaintRemoteDocRows=function(){if(this.dm.docRows)for(var a=0;a<this.dm.docRows.length;a++){var c=this.dm.docRows[a];c.isRemoteDocument()&&c.view.repaintRow()}};a.prototype.renderDocSourceLinks=function(){if(this.dm.isEditable){if(0<j("#"+this.dm.greenLinksPrefix).length){var a=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix);this.dm.dshObj.displayLinks(a)}0<j("#"+this.dm.greenLinksPrefix+
"_bottom").length&&(a=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix+"_bottom"),this.dm.dshObj.displayLinks(a))}};a.prototype.renderSimple=function(a){try{this.isSingleValueListRendering=!this.dm.allowMultiple,this.renderOptions.hideHeader=!0,this.renderComplex(a)}catch(c){return g.log("Problem in DocTableXView.renderSimple:\n"+c),null}return a};a.prototype.renderComplex=function(a){try{this.dm.destroy();a.html("");this.isSingleValueListRendering||a.append(this.renderGreenLinksPlaceholder("top"));
var c="",c=this.renderOptions.hideHeader?c+"headerlessTable":c+"ordtable docreftable documentsTable",e=j('<table class="'+c+'"></table>');a.append(e);this.renderOptions.hideHeader||this.renderTableHeader(e);c="<tbody>";if(0<this.dm.docRows.length)for(var b=0;b<this.dm.docRows.length;b++)c+='<tr id="'+this.dm.docRows[b].view.phElemID+'"></tr>';else this.isSingleValueListRendering&&(c+="<tr><td>",c+=this.renderGreenLinksPlaceholder("top"),c+="</td></tr>");e.append(c+"</tbody>");this.isSingleValueListRendering||
a.append(this.renderGreenLinksPlaceholder("bottom"));if(!this.dm.isInactive||this.dm.clearValues){var d=this.dm.getTablePrefix();a.append('<input type="hidden" id="'+d+'" name="'+d+'"/>')}}catch(l){return g.log("Problem in DocTableXView.renderComplex:\n"+l),null}return a};a.prototype.renderGreenLinksPlaceholder=function(a){var c="";try{c+='<div class="docrefheader">',this.dm.isEditable&&(-1!=a.indexOf("top")&&this.renderOptions.showGreenLinksOnTop&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+
this.dm.greenLinksPrefix+'"></div>'),-1!=a.indexOf("bottom")&&this.renderOptions.showGreenLinksAtBottom&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_bottom"></div>'),-1!=a.indexOf("inline")&&(c+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_inline"></div>')),c+="</div>"}catch(e){g.log("Problem in DocTableXView.renderGreenLinksPlaceholder:\n"+e),c=""}return c};a.prototype.renderTableHeader=function(a){if(a&&0!=a.length)try{var c=
"";if(0<this.dm.getNumberOfRows()){var c=c+"<thead><tr>",e=this.renderOptions.columns;if(e)for(var b=0;b<e.length;b++){var d=this.renderOptions.columns[b];if(d){var l=d.type;"DocumentProperty"==l&&(l+="_"+d.typeDetail);var i=this.renderMethodMap[l];i&&(c+=i.call(this,d))}}c+="</tr></thead>"}a.html(c)}catch(f){g.log("Problem in DocTableXView.renderTableHeader:\n"+f)}};a.prototype.renderExpandCollapseButtonHeader=function(){var a="javascript: "+this.dm.getThisInDOM()+".expandCollapseAllClicked(this);return false;",
a='<th class="docrefexpandcol">'+('<a class="btn btn12 expandAll" href="#" onclick="'+a+'"><i class="expand-small"></i></a>')+('<a class="btn btn12 collapseAll" href="#" onclick="'+a+'"><i class="collapse-small"></i></a>');return a+="</th>"};a.prototype.renderSortingArrowsHeader=function(){return this.dm.isEditable?'<th class="docrefsortcol"></th>':""};a.prototype.renderSequenceNumberHeader=function(a){return'<th class="docrefsortcol">'+c.xmlencode(a.label)+"</th>"};a.prototype.renderThumbnailHeader=
function(a){return'<th class="docrefthumbcol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentSpecHeader=function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentActionsHeader=function(a){return'<th class="docrefactionscol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentDescriptionHeader=function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderApprovalStatusHeader=
function(a){return'<th class="docrefApprovalStatus">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderApprovalStageHeader=function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocProjectNameHeader=function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentVersionHeader=function(a){return'<th class="docrefversioncol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentAuthorHeader=
function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentModifiedDateHeader=function(a){return'<th class="docrefdoccol">'+g.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderLocalRemoteButtonHeader=function(){return'<th class="docrefsortcol"></th>'};a.prototype.renderDeleteButtonHeader=function(){return this.dm.isEditable?'<th class="docrefremovecol"></th>':""};a.prototype.renderReferencePropertyHeader=function(a){var g;g='<th class="docrefdoccol">'+
c.xmlencode(a.label);"Required"==a.visibility&&(g+='&nbsp;<font color="red">*</font>');return g+"</th>"};a.prototype.renderDocAttributeHeader=function(a){var g;g='<th class="docrefdoccol">'+c.xmlencode(a.label);"Required"==a.visibility&&(g+='&nbsp;<font color="red">*</font>');return g+"</th>"};return a});
define("doctablex/DocumentTypeUtils",[],function(){var g=!1,c="ard cf2 cff2 ds2 dd3 dxf dwg scb vlm".split(" "),j=[],a=[],h=function(c){for(var e=0;e<a.length;e++)if(c==a[e].id)return!0;return!1};return{initDocumentTypes:function(c,e){if(c&&(!g||e)){c.graphicExtList&&(j=c.graphicExtList);if(c.docTypeList)for(var b=0;b<c.docTypeList.length;b++){var d=c.docTypeList[b];"1"==d.enabled&&a.push(d)}g=!0}},getIsInitialized:function(){return g},getDocTypeIDByExtension:function(a,e){if(!g)return"00001_0000000005";
var b=a?a.toLowerCase():"",d;a:{for(d=0;d<c.length;d++)if(b==c[d]&&h("00001_0000000001")){d=!0;break a}d=!1}if(d)return"00001_0000000001";a:{for(d=0;d<j.length;d++)if(b==j[d]&&h("00001_0000000004")){d=!0;break a}d=!1}if(d)return"00001_0000000004";if("pagelist"==e&&h("00001_0000000014"))return"00001_0000000014";if(e&&e.indexOf&&-1<e.indexOf("00002_0000000"))return e;switch(b){case "a3d":if(h("00001_0000000003"))return"00001_0000000003";break;case "acd":if(h("00001_0000000020"))return"00001_0000000020";
break;case "mfg":if(h("00001_0000000002"))return"00001_0000000002";break;case "clf":if(h("00001_0000000008"))return"00001_0000000008";break;case "zcp":if(h("00001_0000000008"))return"00001_0000000008";break;case "dae":if(h("00001_0000000017"))return"00001_0000000017";break;case "zae":if(h("00001_0000000016"))return"00001_0000000016";break;case "chp":if(h("00001_0000000018"))return"00001_0000000018"}return"00001_0000000005"}}});
define("attributecategory/Attribute",[],function(){function g(c){this.id=c.id;this.name=c.name;this.description=c.description;this.unitId=c.unitId;this.rsId=c.rsId;this.type=c.type;c.value?this.setValue(c.value,c.valueHyperlink):this.setValue("");this.placedOriginally=c.placedOriginally||!1;this.placedArr=c.placedArr||[];this.isRequired=c.isRequired||!1;this.rs=c.rs;this.restrictType=c.restrictType;this.isCheckBox=c.isCheckBox||!1;this.isDocReference()&&c.docTable&&(this.docTableObj=c.docTable)}g.prototype.isDocReference=
function(){return this.type?"documentreference"==this.type.toLowerCase():"00001_0000000022"==this.unitId};g.prototype.isText=function(){return this.type?"text"==this.type.toLowerCase():"00001_0000000001"==this.unitId};g.prototype.isRichText=function(){return this.type?"richtext"==this.type.toLowerCase():"00001_0000000021"==this.unitId};g.prototype.setIsRequired=function(c){this.isRequired=c};g.prototype.getIsRequired=function(){return!this.isRequired?!1:this.isRequired};g.prototype.setValue=function(c,
g){c||(g=c="");this.value!=c&&(this.value=c,this.valueHyperlink=g)};g.prototype.copyValueFrom=function(c){c&&(this.value=c.value,this.valueHyperlink="undefined"==typeof c.valueHyperlink?"":c.valueHyperlink,this.hiddenDate="undefined"==typeof c.hiddenDate?"":c.hiddenDate,this.oldDate="undefined"==typeof c.oldDate?"":c.oldDate)};return g});
define("doctablex/AJAXDataCache","doctablex/DocTableXUtils doctablex/DocumentTypeUtils attributecategory/Attribute wcr/webcenter_xml wcr/webcenter_html wcr/ObjectArrayCloneUtil jquery underscore".split(" "),function(g,c,j,a,h,k,e,b){var d=null,l={},i={},f=[],n=[],m=[],o=[],p=[],r=[],w=null,x=[],t=[],y=[],s=function(d){try{var b=a.GetFirstFirstLevelChild(d,"error");if(b){var e=a.GetElementText(b,"code"),c=a.GetElementText(b,"message");g.log("SDK error "+e+": "+c);return e+": "+c}}catch(f){return g.log("Problem in findAndGetSDKError() private method."),
"000: Undefined error"}return""};return{getInstance:function(){d||(d={resetDocDataByDocVerID:function(d){d&&(p[d]&&(p[d]=null),r[d]&&(r[d]=null))},getProjCreationSysDefaults:function(d){d&&(i=null);var b=i;b||(i=b={});if(b.request)return b.request.promise();b.request=new e.Deferred;try{var f=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadDefaultSettings&ajax=1",dataType:"xml",context:this});f.fail(function(d,a,b){if(0!=d.status){var d=i,e="Request failed.\n",
e="SESSION_EXP"==b?e+"Session expired, please try again.":e+("Unable to load project creation system defaults.\nServer status: "+a);g.log(e);i=null;d.request.reject(e)}});f.done(function(d){var b=i,e=s(d);if(e)return e="Request failed with SDK error:\n"+e,g.log(e),i=null,b.request.reject(e),b.request.promise();var e={},c=a.GetFirstFirstLevelChild(d,"system_defaults");if(c){e.blankProjectAutoname=a.GetElementText(c,"blank_project_autoname");e.useDefAutoname4BlankProj=a.GetElementText(c,"use_default_autoname_for_blank_project");
e.useDefCategory4BlankProj=a.GetElementText(c,"use_default_category_for_blank_project");if(d=a.GetFirstFirstLevelChild(c,"graphic_files_extensions"))if(d=a.GetFirstLevelChilds(d,"extension")){e.graphicExtList=[];for(var f=0;f<d.length;f++){var p=a.GetElementSelfTextContent(d[f]),p=p.substring(p.indexOf(".")+1);e.graphicExtList.push(p)}}d=[];if(f=a.GetFirstFirstLevelChild(c,"doc_type_list"))if(p=a.GetFirstLevelChilds(f,"doc_type")){e.docTypeList=[];for(var h=0;h<p.length;h++){var m=p[h],f={};f.id=
a.GetElementAttribute(m,"id");d.push(f.id);f.name=a.GetElementText(m,"name");f.labelTag=a.GetElementText(m,"label_tag");f.enabled=a.GetElementText(m,"enabled");f.uploadJSP=a.GetElementText(m,"Upload_JSP");f.typicalExt=a.GetElementText(m,"upload_hint");e.docTypeList.push(f)}}if(e.docTypeList&&0<e.docTypeList.length&&(c=a.GetFirstFirstLevelChild(c,"doctype_autonaming_list")))if(c=a.GetFirstLevelChilds(c,"doctype_autonaming"))for(p=0;p<c.length;p++)if(h=c[p],f=a.GetElementText(h,"doctypeid"))if(f=d.indexOf(f),
!(0>f)&&(f=e.docTypeList[f]))f.anPrefix=a.GetElementText(h,"autoname_prefix"),f.anSuffix=a.GetElementText(h,"autoname_suffix"),f.anCounterLength=a.GetElementText(h,"autoname_counter_length"),f.anOption=a.GetElementText(h,"autoname_option"),f.categoryID=a.GetElementText(h,"category_id"),f.categoryID||(f.categoryID=l),f.categoryOption=a.GetElementText(h,"category_option")}b.request.resolve(e)})}catch(p){alert("Problem in AJAXDataCache.getProjCreationSysDefaults: "+p)}c&&b.request.done(function(a){c.initDocumentTypes(a,
d)});return b.request.promise()},getEffectiveDocTypesSettingsByProjID:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getEffectiveDocTypesSettingsByProjID() method!").promise();b&&(f[d]=null);var c=f[d];c||(c={},f[d]=c);if(c.request)return c.request.promise();c.request=new e.Deferred;try{var i=new e.Deferred,p=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=GetAutonamingSettingsForProject&projectID="+
d+"&ajax=1",dataType:"xml",context:this});p.fail(function(d,a,b){0!=d.status&&(d="Request failed.\n",d="SESSION_EXP"==b?d+"Session expired, please try again.":d+("Unable to load project creation system defaults.\nServer status: "+a),g.log(d),i.reject(d))});p.done(function(b){var e=s(b);if(e)e="Request failed with SDK error:\n"+e,g.log(e),i.reject(e);else{e=[];if(b=a.GetFirstFirstLevelChild(b,"autonaming_info"))if(b=a.GetFirstFirstLevelChild(b,"project_autoname"))if(b=a.GetFirstFirstLevelChild(b,"doctype_autonaming_list"))if(b=
a.GetFirstLevelChilds(b,"doctype_autonaming"))for(var c=0;c<b.length;c++){var f=b[c],p=a.GetElementText(f,"projectid");if(p!=d)alert("Project ID of processed <doctype_autonaming> tag is not the same as 'projectID'!");else{var h={};h.projectID=p;h.id=a.GetElementText(f,"doctypeid");h.anPrefix=a.GetElementText(f,"autoname_prefix");h.anSuffix=a.GetElementText(f,"autoname_suffix");h.anCounterLength=a.GetElementText(f,"autoname_counter_length");h.anOption=a.GetElementText(f,"autoname_option");h.categoryID=
a.GetElementText(f,"category_id");h.categoryID||(h.categoryID=l);h.categoryOption=a.GetElementText(f,"category_option");e.push(h)}}i.resolve(e)}});var h=this.getProjCreationSysDefaults(b);e.when(i,h).done(function(d,b){var a=k.getCloneOfObject(b),e=a.docTypeList;if(d&&e)for(var f=0;f<e.length;f++){var l=e[f].id;if(l)for(var i=0;i<d.length;i++){var g=d[i];if(l==g.id){l=a.docTypeList[f];if("0"==g.anOption||"1"==g.anOption)l.anPrefix=g.anPrefix,l.anSuffix=g.anSuffix,l.anCounterLength=g.anCounterLength,
l.anOption=g.anOption;if("0"==g.categoryOption||"1"==g.categoryOption)l.categoryID=g.categoryID,l.categoryOption=g.categoryOption;break}}}c.request.resolve(a)}).fail(function(d){0!=jqXHR.status&&c.request.reject(d)})}catch(m){alert("Problem in AJAXDataCache.getDocTypeSettingsByProjID: "+m)}return c.request.promise()},getDocTemplatesByProjID:function(d,b,f){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocTemplatesByProjID() method!").promise();f&&
(n[d]=null);if((f=n[d])&&!f.isThumbnailsLoaded&&b)f=n[d]=null;f||(f={},n[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;f.isThumbnailsLoaded=b;try{var c=window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadTemplateDocuments&projectID="+d+"&ajax=1";b&&(c+="&loadThumbnails=1");var i=e.ajax({type:"GET",url:c,dataType:"xml",context:this});i.fail(function(b,a,e){if(0!=b.status){var b=n[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":
f+("Unable to load project creation system defaults.\nServer status: "+a);g.log(f);n[d]=null;b.request.reject(f)}});i.done(function(e){var f=n[d],c=s(e);if(c)return c="Request failed with SDK error:\n"+c,g.log(c),n[d]=null,f.request.reject(c),f.request.promise();var i=function(d,b){var e={};if(d){e.id=a.GetElementText(d,"document_id");e.docVerID=a.GetElementAttribute(d,"id");e.docVerIdx=a.GetElementText(d,"version_number");e.categoryID=a.GetElementText(d,"category_id");e.categoryID||(e.categoryID=
l);e.docTypeID=a.GetElementText(d,"doctype_id");var f=a.GetFirstFirstLevelChild(d,"document");e.name=a.GetElementText(f,"name");e.thumbnailURL=a.GetElementText(f,"thumbnail_url");b&&(e.folderID=b.id?b.id:"",e.folderName=b.name?b.name:"")}return e},c=[];if(e=a.GetFirstFirstLevelChild(e,"template_documents")){c.tempProjID=a.GetElementText(e,"template_project_id");var h=a.GetFirstFirstLevelChild(e,"template_docs");if(h&&(h=a.GetFirstFirstLevelChild(h,"folder_doc_list"))){var p=a.GetFirstLevelChilds(h,
"folder");if(p)for(var m=0;m<p.length;m++){var o=p[m],j={};j.id=a.GetElementAttribute(o,"id");j.name=a.GetElementText(o,"name");if(o=a.GetFirstFirstLevelChild(o,"doc_version_checkout_list"))if(o=a.GetFirstLevelChilds(o,"doc_version_checkout"))for(var k=0;k<o.length;k++){var u=a.GetFirstFirstLevelChild(o[k],"doc_version");c.push(i(u,j))}}if(o=a.GetFirstFirstLevelChild(h,"doc_version_checkout_list"))if(o=a.GetFirstLevelChilds(o,"doc_version_checkout"))for(k=0;k<o.length;k++)u=a.GetFirstFirstLevelChild(o[k],
"doc_version"),c.push(i(u))}if(b&&(i=a.GetFirstFirstLevelChild(e,"template_docs_thumbnail")))if(i=a.GetFirstLevelChilds(i,"template_doc_thumbnail"))for(e=0;e<i.length;e++){h=i[e];p=a.GetElementText(h,"id");for(m=0;m<c.length;m++)if(j=c[m],p==j.id){j.thumbnailURL=a.GetElementText(h,"thumbnail");break}}}f.request.resolve(c)})}catch(h){alert("Problem in AJAXDataCache.getDocTemplatesByProjID: "+h)}return f.request.promise()},getFoldersByProjID:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getFoldersByProjID() method!").promise();
b&&(m[d]=null);var f=m[d];f||(f={},m[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:"GetDocUploadInfo.jsp?action=GetSingleProjectFolders&projectID="+d+"&ajax=1&loadfolderpermissions=1",dataType:"xml",context:this});c.fail(function(b,a,e){if(0!=b.status){var b=m[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load project upload folders.\nServer status: "+a);g.log(f);m[d]=null;b.request.reject(f)}});
c.done(function(b){var e=m[d],f=s(b);if(f)return f="Request failed with SDK error:\n"+f,g.log(f),m[d]=null,e.request.reject(f),e.request.promise();f=[];if(b=a.GetFirstFirstLevelChild(b,"upload_projects")){var c=a.GetFirstFirstLevelChild(b,"project");if(c){b=a.GetElementText(c,"root_upload_enabled");if(null!=b&&"1"==b){var b={id:"0",name:""},l=a.GetElementText(c,"root_change_prop_enabled");b.changePropPerm=l&&"1"==l;f.push(b)}if(b=a.GetFirstFirstLevelChild(c,"folder_list"))if(c=a.GetFirstLevelChilds(b,
"folder"))for(l=0;l<c.length;l++){var i=c[l],b={};b.id=a.GetElementAttribute(i,"id");b.name=a.GetElementText(i,"name");var h=!1;if((i=a.GetFirstLevelChilds(i,"permission"))&&0<i.length)h=(h=a.GetElementText(i[0],"update"))&&"1"==h;b.changePropPerm=h;f.push(b)}}}e.request.resolve(f)})}catch(l){alert("Problem in AJAXDataCache.getFoldersByProjID: "+l)}return f.request.promise()},getDocVersionsByProjID:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocVersionsByProjID() method!").promise();
b&&(o[d]=null);var f=o[d];f||(f={},o[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:"GetDocumentList.jsp?projectID="+d+"&ajax=1",dataType:"xml",context:this});c.fail(function(b,a,e){if(0!=b.status){var b=o[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load project documents.\nServer status: "+a);g.log(f);o[d]=null;b.request.reject(f)}});c.done(function(b){var e=o[d],f=s(b);if(f)return f="Request failed with SDK error:\n"+
f,g.log(f),o[d]=null,e.request.reject(f),e.request.promise();f=[];if(b=a.GetFirstFirstLevelChild(b,"document_list"))if(b=a.GetFirstLevelChilds(b,"document"))for(var c=0;c<b.length;c++){var l=b[c],i={};i.id=a.GetElementText(l,"document_version_id");i.name=a.GetElementText(l,"document_name");i.versionIndex=a.GetElementText(l,"document_version");i.revisionIndex=a.GetElementText(l,"document_revision");f.push(i)}e.request.resolve(f)})}catch(l){alert("Problem in AJAXDataCache.getdocByProjID: "+l)}return f.request.promise()},
getDocInfoWithThumbnail:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocInfoWithThumbnail() method!").promise();b&&(p[d]=null);var f=p[d];f||(f={},p[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=window.webcenterConfig.jspBaseUrl+"GetDocumentHistory.jsp?docversionid="+d,i=e.ajax({type:"GET",url:c+"&projectinfo=1&includetemplates=1&approvalinfo=1&limitdocversions=1&thumbnailurl=1&dateformat=2&ajax=1",
dataType:"xml",context:this});i.fail(function(b,a,e){if(0!=b.status){var b=p[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load document details (version "+d+").\nServer status: "+a);g.log(f);p[d]=null;b.request.reject(f)}});i.done(function(b){var e=p[d],f=null,c=s(b);if(c)return 0==c.indexOf("021")||0==c.indexOf("005")?(f=l,e.request.resolve(f)):(f="Request failed with SDK error:\n"+c,g.log(f),p[d]=null,e.request.reject(f)),e.request.promise();if(b=
a.GetFirstFirstLevelChild(b,"document_info")){f={};f.docID=a.GetElementText(b,"docID");f.latestDocVerIdx=a.GetElementText(b,"last_version_number");f.docName=a.GetElementText(b,"document_name");f.docDesc=a.GetElementText(b,"description");f.modDate=a.GetElementText(b,"modification_date");f.docIsUrl=a.GetElementBoolean(b,"is_url");f.docCheckedOutOwner=a.GetElementText(b,"checked_out_owner_id");if(c=a.GetFirstFirstLevelChild(b,"permission")){var i={};i.view="1"==a.GetElementText(c,"view");i.add="1"==
a.GetElementText(c,"add");i.change="1"==a.GetElementText(c,"update");i.remove="1"==a.GetElementText(c,"delete");i.checkout="1"==a.GetElementText(c,"checkout");i.download="1"==a.GetElementText(c,"download");i.changeApp="1"==a.GetElementText(c,"change_approval");i.changeTask="1"==a.GetElementText(c,"change_task");i.changeBOM="1"==a.GetElementText(c,"change_bom");i.isProjMgr="1"==a.GetElementText(c,"can_manage_this_project");f.userPerms=i}if(c=a.GetFirstFirstLevelChild(b,"document_version")){f.docVerID=
a.GetElementText(c,"docVersionID");f.docVerIdx=a.GetElementText(c,"version_number");f.docVerDesc=a.GetElementText(c,"version_comments");f.docRevIdx=a.GetElementText(c,"revision");f.docRevLetter=a.GetElementText(c,"revision_letter");f.docTypeID=a.GetElementText(c,"doc_type_id");f.thumbnailURL=a.GetElementText(c,"thumb_url");f.docSourceId=a.GetElementText(c,"source_id");f.has3dView=a.GetElementText(c,"has_3d_view");var m=a.GetFirstFirstLevelChild(c,"author");if(m){var i={},o=a.GetFirstFirstLevelChild(m,
"user");if(o){i.isUser=!0;i.id=a.GetElementText(o,"userID");var m=a.GetElementText(o,"lastname"),j=a.GetElementText(o,"firstname"),o=a.GetElementText(o,"login");i.fullName=h.getUserNameString(j,m,o)}f.docVerAuthor=i}i={};i.cycleStatusCode=a.GetElementText(c,"document_approval_cycle_code");i.cycleStatus=a.GetElementText(c,"document_approval_cycle_status");i.status=a.GetElementText(c,"document_approval_status");i.statusID=a.GetElementText(c,"document_approval_code");i.cycleStatusStringCode={"-1":"no_approval_rule",
"0":"cycle_started",1:"cycle_stopped",2:"cycle_finished"}[i.cycleStatusCode];i.stageIdx=a.GetElementText(c,"stage_index");if(c=a.GetFirstFirstLevelChild(c,"stages"))if(c=a.GetFirstLevelChilds(c,"stage"))for(m=0;m<c.length;m++)if(j=c[m],a.GetElementText(j,"index")==i.stageIdx){i.stageID=a.GetElementText(j,"stage_id");i.stageName=a.GetElementText(j,"name");break}f.appStatus=i}f.appTypeList=[];if(c=a.GetFirstFirstLevelChild(b,"approvaltypes"))if(i=a.GetFirstLevelChilds(c,"approvaltype"))for(c=0;c<i.length;c++)m=
i[c],j={},j.id=a.GetElementText(m,"approvalid"),j.name=a.GetElementText(m,"type_name"),j.translName=a.GetElementText(m,"approvalname"),j.level=a.GetElementText(m,"approval_level"),j.dispOrder=a.GetElementText(m,"display_order"),j.icon=a.GetElementText(m,"icon"),f.appTypeList.push(j);f.projList=[];if(b=a.GetFirstFirstLevelChild(b,"project_list"))if(b=a.GetFirstLevelChilds(b,"project"))for(c=0;c<b.length;c++)m=b[c],i={},i.id=a.GetElementAttribute(m,"id"),i.name=a.GetElementText(m,"name"),m=a.GetElementText(m,
"is_template"),i.isTemplate=m&&"1"==m,f.projList.push(i)}e.request.resolve(f)})}catch(m){alert("Problem in AJAXDataCache.getDocInfoWithThumbnail: "+m)}return f.request.promise()},getDocAttrCatInfo:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocAttrCatInfo() method!").promise();b&&(r[d]=null);var f=r[d];f||(f={},r[d]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+
"GetAttributes.jsp?docverid="+d+"&ajax=1",dataType:"xml",context:this});c.fail(function(b,a,e){if(0!=b.status){var b=r[d],f="Request failed.\n",f="SESSION_EXP"==e?f+"Session expired, please try again.":f+("Unable to load attribute category of document version with ID: "+d+").\nServer status: "+a);g.log(f);r[d]=null;b.request.reject(f)}});c.done(function(b){var f=r[d],e=null,c=s(b);if(c)if(0==c.indexOf("043")||0==c.indexOf("005"))e=l;else return e="Request failed with SDK error:\n"+c,g.log(e),r[d]=
null,f.request.reject(e),f.request.promise();null==e&&((b=a.GetFirstFirstLevelChild(b,"attribute_category"))?(e={},e.id=a.GetElementText(b,"id"),e.id?(e.name=a.GetElementText(b,"name"),e.userUnits=a.GetElementText(b,"user_units")):e=l):e=l);f.request.resolve(e)})}catch(i){alert("Problem in AJAXDataCache.getDocAttrCatInfo: "+i)}return f.request.promise()},getGlobalDocumentSettings:function(d){d&&(w=null);d=w;d||(w=d={});if(d.request)return d.request.promise();d.request=new e.Deferred;try{var b=e.ajax({type:"GET",
url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=LoadGlobalDocumentSettings",dataType:"xml",context:this});b.fail(function(d,b,a){if(0!=d.status){var d=w,e="Request failed.\n",e="SESSION_EXP"==a?e+"Session expired, please try again.":e+("Unable to load global settings.\nServer status: "+b);g.log(e);w=null;d.request.reject(e)}});b.done(function(d){var b=w,e=s(d);if(e)return d="Request failed with SDK error:\n"+e,g.log(d),w=null,b.request.reject(d),b.request.promise();e={};(d=a.GetFirstFirstLevelChild(d,
"site_defaults"))?(e.approvalRestartUploaderCanOverrule=a.GetElementText(d,"approval_restart_option"),e.approvalRestartOption=a.GetElementText(d,"approval_restart_enable_checkbox"),e.allowRaiseRevision=a.GetElementText(d,"allow_raise_revision"),e.openCadType=a.GetElementText(d,"open_cad_type")):e=l;b.request.resolve(e)})}catch(f){alert("Problem in AJAXDataCache.getGlobalDocumentSettings: "+f)}return d.request.promise()},getDocDownloadPerspectives:function(d,b,f){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();
if(!b||0==b.length)return e.Deferred().reject("Document type ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();f&&(x[b]=null);f=x[b];f||(f={},x[b]=f);if(f.request)return f.request.promise();f.request=new e.Deferred;try{var c=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocumentPerspectives.jsp?docVerID="+d,dataType:"xml",context:this});c.fail(function(a,e,f){if(0!=a.status){var a=x[b],c="Request failed.\n",c="SESSION_EXP"==f?c+"Session expired, please try again.":
c+("Unable to load download perspectives for document version with ID: "+d+").\nServer status: "+e);g.log(c);x[b]=null;a.request.reject(c)}});c.done(function(d){var e=x[b],f=s(d);if(f)return f="Request failed with SDK error:\n"+f,g.log(f),x[b]=null,e.request.reject(f),e.request.promise();f=null;if(d=a.GetFirstFirstLevelChild(d,"perspective_name_list"))for(var f=[],d=a.GetFirstLevelChilds(d,"perspective_name"),c=0;c<d.length;c++){var i=d[c],l={};l.name=a.GetElementText(i,"name");l.longName=a.GetElementText(i,
"long_name");f.push(l)}e.request.resolve(f)})}catch(i){alert("Problem in AJAXDataCache.getDocDownloadPerspectives: "+i)}return f.request.promise()},getAttribute:function(d,b){if(!d||0==d.length)return e.Deferred().reject("Attribute Name has to be specified in AJAXDataCache.getAttribute() method!").promise();b&&(t[d]=null);var a=t[d];a||(a={},t[d]=a);if(a.request)return a.request.promise();a.request=new e.Deferred;y.push(d);this.fetchAttributes();return a.request.promise()},fetchAttributes:b.debounce(function(){for(var d=
window.webcenterConfig.jspBaseUrl+"GetAttributeListXML.jsp?",b=y,f=0;f<y.length;f++)0<f&&(d+="&"),d+="attrname="+encodeURIComponent(y[f]);d=e.ajax({type:"GET",url:d,dataType:"xml",context:this});d.fail(function(d,a,f){if(0!=d.status){d="Request failed.\n";d="SESSION_EXP"==f?d+"Session expired, please try again.":d+("Unable to load attributes with names: "+b+").\nServer status: "+a);g.log(d);for(a=0;a<b.length;a++){var f=b[a],e=t[f];t[f]=null;e.request.reject(d)}}});d.done(function(d){var f=s(d);if(f){var e=
"Request failed with SDK error:\n"+f;g.log(e);for(f=0;f<b.length;f++){var c=b[f],i=t[c];t[c]=null;i.request.reject(e)}}if(f=a.GetFirstFirstLevelChild(d,"attributes"))if(f=a.GetFirstFirstLevelChild(f,"attribute_list")){d=a.GetFirstLevelChilds(f,"attribute");for(f=0;f<d.length;f++)i=d[f],e=new j({name:a.GetElementText(i,"name"),id:a.GetElementAttribute(i,"id"),description:a.GetElementAttribute(i,"description"),unitId:a.GetElementText(i,"attribute_unit_id"),rsId:a.GetElementText(i,"restricted_set_id"),
placedArr:[],value:""}),i=b.indexOf(e.name),-1!=i&&b.splice(i,1),(i=t[e.name])&&i.request.resolve(e)}for(f=0;f<b.length;f++)c=b[f],i=t[c],i.request.reject("Attribute "+c+" not found")});y=[]},50)});return d},isEmptyValue:function(d){return d&&d===l},getEmptyValue:function(){return l}}});
!function(g){function c(){this._events={};this._conf&&j.call(this,this._conf)}function j(a){a&&(this._conf=a,a.delimiter&&(this.delimiter=a.delimiter),a.maxListeners&&(this._events.maxListeners=a.maxListeners),a.wildcard&&(this.wildcard=a.wildcard),a.newListener&&(this.newListener=a.newListener),this.wildcard&&(this.listenerTree={}))}function a(a){this._events={};this.newListener=!1;j.call(this,a)}function h(a,b,d,c){if(!d)return[];var i=[],f,g,m,o;m=b.length;o=b[c];var p=b[c+1];if(c===m&&d._listeners){if("function"===
typeof d._listeners)a&&a.push(d._listeners);else{b=0;for(c=d._listeners.length;b<c;b++)a&&a.push(d._listeners[b])}return[d]}if("*"===o||"**"===o||d[o]){if("*"===o){for(f in d)"_listeners"!==f&&d.hasOwnProperty(f)&&(i=i.concat(h(a,b,d[f],c+1)));return i}if("**"===o){(o=c+1===m||c+2===m&&"*"===p)&&d._listeners&&(i=i.concat(h(a,b,d,m)));for(f in d)"_listeners"!==f&&d.hasOwnProperty(f)&&("*"===f||"**"===f?(d[f]._listeners&&!o&&(i=i.concat(h(a,b,d[f],m))),i=i.concat(h(a,b,d[f],c))):i=f===p?i.concat(h(a,
b,d[f],c+2)):i.concat(h(a,b,d[f],c)));return i}i=i.concat(h(a,b,d[o],c+1))}(g=d["*"])&&h(a,b,g,c+1);if(d=d["**"])if(c<m)for(f in d._listeners&&h(a,b,d,m),d)"_listeners"!==f&&d.hasOwnProperty(f)&&(f===p?h(a,b,d[f],c+2):f===o?h(a,b,d[f],c+1):(m={},m[f]=d[f],h(a,b,{"**":m},c+1)));else d._listeners?h(a,b,d,m):d["*"]&&d["*"]._listeners&&h(a,b,d["*"],m);return i}var k=Array.isArray?Array.isArray:function(a){return"[object Array]"===Object.prototype.toString.call(a)};a.prototype.delimiter=".";a.prototype.setMaxListeners=
function(a){this._events||c.call(this);this._events.maxListeners=a;this._conf||(this._conf={});this._conf.maxListeners=a};a.prototype.event="";a.prototype.once=function(a,b){this.many(a,1,b);return this};a.prototype.many=function(a,b,d){function c(){0===--b&&i.off(a,c);d.apply(this,arguments)}var i=this;if("function"!==typeof d)throw Error("many only accepts instances of Function");c._origin=d;this.on(a,c);return i};a.prototype.emit=function(){this._events||c.call(this);var a=arguments[0];if("newListener"===
a&&!this.newListener&&!this._events.newListener)return!1;if(this._all){for(var b=arguments.length,d=Array(b-1),l=1;l<b;l++)d[l-1]=arguments[l];l=0;for(b=this._all.length;l<b;l++)this.event=a,this._all[l].apply(this,d)}if("error"===a&&!this._all&&!this._events.error&&(!this.wildcard||!this.listenerTree.error)){if(arguments[1]instanceof Error)throw arguments[1];throw Error("Uncaught, unspecified 'error' event.");}var i;this.wildcard?(i=[],b="string"===typeof a?a.split(this.delimiter):a.slice(),h.call(this,
i,b,this.listenerTree,0)):i=this._events[a];if("function"===typeof i){this.event=a;if(1===arguments.length)i.call(this);else if(1<arguments.length)switch(arguments.length){case 2:i.call(this,arguments[1]);break;case 3:i.call(this,arguments[1],arguments[2]);break;default:b=arguments.length;d=Array(b-1);for(l=1;l<b;l++)d[l-1]=arguments[l];i.apply(this,d)}return!0}if(i){b=arguments.length;d=Array(b-1);for(l=1;l<b;l++)d[l-1]=arguments[l];i=i.slice();l=0;for(b=i.length;l<b;l++)this.event=a,i[l].apply(this,
d);return 0<i.length||this._all}return this._all};a.prototype.on=function(a,b){if("function"===typeof a)return this.onAny(a),this;if("function"!==typeof b)throw Error("on only accepts instances of Function");this._events||c.call(this);this.emit("newListener",a,b);if(this.wildcard){a:{for(var d=a,d="string"===typeof d?d.split(this.delimiter):d.slice(),l=0,i=d.length;l+1<i;l++)if("**"===d[l]&&"**"===d[l+1])break a;l=this.listenerTree;for(i=d.shift();i;){l[i]||(l[i]={});l=l[i];if(0===d.length){l._listeners?
"function"===typeof l._listeners?l._listeners=[l._listeners,b]:k(l._listeners)&&(l._listeners.push(b),l._listeners.warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&l._listeners.length>d&&(l._listeners.warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",l._listeners.length),console.trace()))):l._listeners=b;break a}i=d.shift()}}return this}this._events[a]?
"function"===typeof this._events[a]?this._events[a]=[this._events[a],b]:k(this._events[a])&&(this._events[a].push(b),this._events[a].warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&this._events[a].length>d&&(this._events[a].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[a].length),console.trace()))):this._events[a]=b;return this};
a.prototype.onAny=function(a){this._all||(this._all=[]);if("function"!==typeof a)throw Error("onAny only accepts instances of Function");this._all.push(a);return this};a.prototype.addListener=a.prototype.on;a.prototype.off=function(a,b){if("function"!==typeof b)throw Error("removeListener only takes instances of Function");var d,c=[];if(this.wildcard)d="string"===typeof a?a.split(this.delimiter):a.slice(),c=h.call(this,null,d,this.listenerTree,0);else{if(!this._events[a])return this;d=this._events[a];
c.push({_listeners:d})}for(var i=0;i<c.length;i++){var f=c[i];d=f._listeners;if(k(d)){for(var g=-1,m=0,o=d.length;m<o;m++)if(d[m]===b||d[m].listener&&d[m].listener===b||d[m]._origin&&d[m]._origin===b){g=m;break}if(0>g)break;this.wildcard?f._listeners.splice(g,1):this._events[a].splice(g,1);0===d.length&&(this.wildcard?delete f._listeners:delete this._events[a])}else if(d===b||d.listener&&d.listener===b||d._origin&&d._origin===b)this.wildcard?delete f._listeners:delete this._events[a]}return this};
a.prototype.offAny=function(a){var b=0,d=0,c;if(a&&this._all&&0<this._all.length){c=this._all;b=0;for(d=c.length;b<d;b++)if(a===c[b]){c.splice(b,1);break}}else this._all=[];return this};a.prototype.removeListener=a.prototype.off;a.prototype.removeAllListeners=function(a){if(0===arguments.length)return!this._events||c.call(this),this;if(this.wildcard)for(var b="string"===typeof a?a.split(this.delimiter):a.slice(),b=h.call(this,null,b,this.listenerTree,0),d=0;d<b.length;d++)b[d]._listeners=null;else{if(!this._events[a])return this;
this._events[a]=null}return this};a.prototype.listeners=function(a){if(this.wildcard){var b=[],a="string"===typeof a?a.split(this.delimiter):a.slice();h.call(this,b,a,this.listenerTree,0);return b}this._events||c.call(this);this._events[a]||(this._events[a]=[]);k(this._events[a])||(this._events[a]=[this._events[a]]);return this._events[a]};a.prototype.listenersAny=function(){return this._all?this._all:[]};"function"===typeof define&&define.amd?define("lib/EventEmitter2",[],function(){return a}):g.EventEmitter2=
a}("undefined"!==typeof process&&"undefined"!==typeof process.title&&"undefined"!==typeof exports?exports:window);define("utils/WCEvent",["lib/EventEmitter2"],function(g){if(!window.WCEvent){var c=window,j=new g({wildcard:!0,delimiter:"."});c.WCEvent={on:function(){j.on.apply(j,arguments)},emit:function(){j.emit.apply(j,arguments)}}}return window.WCEvent});
define("component/actionbuttons/AbstractButton",["jquery","underscore","doctablex/DocTableXUtils","doctablex/AJAXDataCache"],function(g,c,j,a){j=function(a,c){this.btnCtx=null;c&&(this.btnCtx=c);this.baseUrl=window.webcenterConfig.jspBaseUrl||"./";this.loaded=!1;this.afterLoadCallbacks=[];this.docVerId=a;this.isVisible=!1;this.loadDocumentInfo()};j.prototype.loadDocumentInfo=function(){if(this.docVerId){var h=a.getInstance().getDocInfoWithThumbnail(this.docVerId);g.when(h).done(c.bind(function(a){this.loaded=
!0;this.updateDocumentInfo(a);this.render();if(0<this.afterLoadCallbacks.length){for(a=0;a<this.afterLoadCallbacks.length;a++)this.afterLoadCallbacks[a]();this.afterLoadCallbacks=[]}},this))}};j.prototype.render=function(){this.renderBtn(this.btnCtx)};j.prototype.renderBtn=function(a){a&&(this.loaded?(a.empty(),this.isVisible&&this._renderBtnImpl(a)):this.afterLoadCallbacks.push(c.bind(this.renderBtn,this,a)))};j.prototype._renderBtnImpl=function(){};j.prototype.openInNewTab=function(a){a=window.open(a,
"_blank");null!=a&&a.focus()};j.prototype.setBtnContext=function(a){this.btnCtx=a;this.render()};j.prototype.updateDocumentInfo=function(){};return j});
define("tpl",["underscore"],function(g){var c={};return{load:function(c,a,h){g.templateSettings.variable="d";a.toUrl(c+".tpl.html");a(["lib/text!"+c+".tpl.html","underscore"],function(a,c){var b=c.template(a);h(b)})},write:function(j,a,h){if(a in c){var k=g.template("define('<%-d.pluginName%>!<%=d.moduleName%>', function(){return <%=d.func%>});");h(k({pluginName:j,moduleName:a,func:c[a]}))}}}});
define("tpl!component/actionbuttons/InlineUploadNewVersionBlock",function(){return function(g){var c,j;j=""+('<input type="hidden" name="originalDocVersionID" value="'+(null==(c=g.docVerId)?"":_.escape(c))+'" />\r\n<input type="hidden" name="docName_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.docName)?"":_.escape(c))+'" />\r\n<input type="hidden" name="docID_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.docId)?"":_.escape(c))+'" />\r\n<div style="float:left;">\r\n\t<table width="100%">\r\n\t\t<tr>\r\n\t\t\t<td width="1px" class="darktext_darklink_11">\r\n\t\t\t\t<span class="nobr">'+
(null==(c=g.i18n("CHECKINNEWVERWITHCOMMENT"))?"":_.escape(c))+':<span class="esko-green">*</span>&nbsp;</span>\r\n\t\t\t</td>\r\n\t\t\t<td width="1px">\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t<input size="30" type="file" name="newVersionDocFile_'+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t\t<td align="left">\r\n\t\t\t\t<input  size="50" type="text" name="newVersionDocDesc_'+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.formdata.newVersionDocDesc)?
"":_.escape(c))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\r\n\t\t<\!-- Raise revision checkbox --\>\r\n\t  \t<\!-- only show this HTML control if the setting is enabled --\>\r\n\t  \t');g.allowRaiseRevision&&(j+='\r\n\t  \t  \t<tr>\r\n\t\t\t\t<td align="left" nowrap="nowrap" class="darktext_darklink_bold_12" style="padding-top: 10px;">\r\n\t\t\t\t\t'+(null==(c=g.i18n("REVISION"))?"":_.escape(c))+':\r\n\t\t\t\t</td>\r\n\t\t\t\t<td class="darktext_darklink_11" style="padding-top: 10px;">\r\n\t\t\t\t\t<label>\r\n\t\t\t\t\t\t<input class="datafield" style="position: relative; vertical-align: middle; bottom: 1px;" type="checkbox" value="true" name="incrementRevision_'+
(null==(c=g.docVerId)?"":_.escape(c))+'" '+(null==(c=g.incrementRevision?'checked="checked"':"")?"":_.escape(c))+"/>\r\n\t\t\t\t\t\t"+(null==(c=g.i18n("INCREMENT_TO"))?"":_.escape(c))+"&nbsp;\r\n\t\t\t\t\t\t\t<b>\r\n\t\t\t\t\t\t\t\t"+(null==(c=g.i18n("REVISION"))?"":_.escape(c))+"&nbsp;"+(null==(c=g.lastRevision)?"":_.escape(c))+"\r\n\t\t\t\t\t\t\t</b>\r\n\t\t\t\t\t</label>\r\n\t\t\t\t</td>\r\n\t\t\t</tr>\r\n\t  \t");j+="\r\n\t\t\r\n\t\t\r\n\t\t<\!-- Show the 'update related projects' checkbox if needed --\>\r\n\t\t";
1<g.projectList.length&&!g.alwayUpdateAllProject&&(j+='\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t'+(null==(c=g.i18n("PROJ_TASK_DOC_MULPROJ"))?"":_.escape(c))+'\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\r\n\t\t<tr>\r\n\t\t\t<td  colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t<input  type="checkbox" '+
(null==(c=!1===g.updateAllProjects?"":'checked="checked"')?"":_.escape(c))+' class="datafield" name="updateAllProjects_'+(null==(c=g.docVerId)?"":_.escape(c))+'" style="position: relative; vertical-align: middle; bottom: 1px;"/>\r\n\t\t\t\t'+(null==(c=g.i18n("PROJ_TASK_DOC_MULPROJ_UPDATEALL"))?"":_.escape(c))+"\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t");j+='\r\n\t\t\r\n\t\t<tr>\r\n\t\t\t<td height="10">\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t\r\n\t\t<\!-- APPROVAL --\>\r\n\t\t';
g.approvalRestartEnableCheckbox||(j+='\r\n\t\t\t<\!-- set the default value input field --\>\r\n\t\t\t<tr><td><input type="hidden"  name="startApprovalDefaultValue'+(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"startApprovalDefaultValue"+(null==(c=g.docVerId)?"":_.escape(c))+'"\r\n\t\t\t\tvalue="'+(null==(c=g.initialStartApprovalValue?"1":"0")?"":_.escape(c))+'"></input>\t</td></tr>\t\r\n\t\t');j+="\r\n\t\t\r\n\t\t";if(2>g.projectList.length){j+=" <\!-- not linked --\>\r\n\t\t\t";
if(g.approvalCycleState){j+="\r\n\t\t\t\t";if("cycle_started"==g.approvalCycleState||"cycle_stopped"==g.approvalCycleState||"cycle_finished"==g.approvalCycleState)j+='\r\n\t\t  \t\t\t<tr id="'+(null==(c=g.idprefix)?"":_.escape(c))+"approvalCheckBox"+(null==(c=g.docVerId)?"":_.escape(c))+'">\r\n\t\t  \t\t\t\t<td class="darktext_darklink_11">&nbsp;</td>\r\n\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" colspan="2">\r\n\t\t\t    \t  \t\t',j=g.approvalRestartEnableCheckbox?j+('\r\n\t\t\t    \t  \t\t\t<\!-- show checkbox --\>\r\n\t\t\t    \t  \t\t\t<input type="checkbox" name="AppCycleFlag'+
(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"AppCycleFlag"+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield"\r\n\t\t\t    \t  \t\t\t\t'+(null==(c=!0===g.AppCycleFlag||!1!==g.AppCycleFlag&&g.initialStartApprovalValue?' checked="checked"':"")?"":_.escape(c))+' ></input>\r\n\t\t\t  \t\t\t\t\t<img src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="10" height="1"/>\r\n\t\t\t  \t\t\t\t\t'+(null==(c=g.i18n("DOCCHECKINAPPROVALCYCLE_TAG"))?
"":_.escape(c))+"\r\n\t\t\t    \t  \t\t"):j+("\r\n\t\t\t    \t  \t\t\t<\!-- CheckBox is not enabled, only show a feedback string --\>\r\n\t\t\t    \t  \t\t\t"+(null==(c=g.initialStartApprovalValue?g.i18n("APPROVAL_WILL_AUTO_START"):g.i18n("APPROVAL_WILL_NOT_AUTO_START"))?"":_.escape(c))+"\r\n\t\t\t    \t  \t\t"),j+="\r\n\t\t  \t\t\t\t</td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t\r\n\t\t\t\t\t<\!-- show calendar --\>\r\n\t\t\t\t\t","1"==g.showDueDate&&(j+='\r\n\t\t\t\t\t\t<tr><td height="5"><img src="'+(null==
(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="1" height="10"/></td></tr>   \r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td/>\r\n\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left" valign="middle" colspan="2">\r\n\t\t\t\t\t\t\t\t<table>\r\n\t\t\t\t\t\t\t\t\t<tr colspan="3" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"approvalDueDate"+(null==(c=g.docVerId)?"":_.escape(c))+'">\r\n\t\t\t\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left">\t\r\n\t\t\t\t\t\t  \t\t\t\t\t<\!-- specify new due date --\>\r\n\t\t\t\t\t\t    \t  \t\t\t'+
(null==(c=g.i18n("NEW_DUEDATE"))?"":_.escape(c))+':&nbsp;\r\n\t\t\t\t\t\t\t   \t  \t\t</td>\r\n\t\t\t\t\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" nowrap="nowrap">\r\n\t\t\t\t\t\t\t\t    \t  \t<\!-- due date controls --\>\r\n\t\t\t\t\t\t\t\t\t\t\t<table border="0" cellspacing="0" cellpadding="0" >\r\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" readonly="readonly" value="'+(null==(c=g.dueDateH1)?"":_.escape(c))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input type="hidden" name="save_due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"save_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" value="'+(null==(c=g.dueDateH2)?"":_.escape(c))+'" />\r\n\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<\!--Put new calendar there --\>\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input class="filter datafield" value="'+
(null==(c=g.dueDate)?"":_.escape(c))+'" type="text" name="longFormat_due_date'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="20" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a target="_self" href="#" onclick="javascript:$(\'#'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'\')[0].focus(); return false;">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img height="15" src="'+
(null==(c=g.baseUrl)?"":_.escape(c))+'images/show-calendar.gif"  width="24" border="0" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t    \t\t<script type="text/javascript">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$(function() {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+(null==(c=g.idprefix)?"":_.escape(c))+"longFormat_due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'").datepicker({dateFormat: "M dd, yy", \r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tonClose: function(dateText, inst) {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar element = $("#'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'")[0];\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif(element && element.selectedIndex == 0){\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\telement.selectedIndex = (36 + 1);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar dateVal = dateText;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif (dateText != \'\')\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t{\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar date = new Date(dateText);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tdateVal = formatDate(date, "MM/dd/yyyy");\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+
(null==(c=g.idprefix)?"":_.escape(c))+"due_date"+(null==(c=g.docVerId)?"":_.escape(c))+'").val(dateVal);\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<\/script>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<style type="text/css">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    #ui-datepicker-div\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t        z-index: 9999999;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    }\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</style>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td><img src="'+
(null==(c=g.baseUrl)?"":_.escape(c))+'images/clearpixel.gif" width="5" height="1"/></td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="save_due_periodOfDay'+(null==(c=g.docVerId)?"":_.escape(c))+'" size="10" id="'+(null==(c=g.idprefix)?"":_.escape(c))+"save_due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'" value="0"/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    <select name="due_periodOfDay'+(null==(c=g.docVerId)?"":_.escape(c))+'" id="'+(null==(c=g.idprefix)?
"":_.escape(c))+"due_periodOfDay"+(null==(c=g.docVerId)?"":_.escape(c))+'" class="datafield">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="-1">---</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t     \t <option value="0" >00:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="1" >00:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="2" >01:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="3" >01:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="4" >02:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="5" >02:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="6" >03:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="7" >03:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="8" >04:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="9" >04:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="10">05:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="11">05:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="12">06:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="13">06:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="14">07:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="15">07:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="16">08:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="17">08:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="18">09:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="19">09:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="20">10:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="21">10:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="22">11:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="23">11:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="24">12:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="25">12:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="26">13:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="27">13:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="28">14:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="29">14:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="30">15:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="31">15:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="32">16:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="33">16:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="34">17:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="35">17:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="36">18:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="37">18:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="38">19:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="39">19:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="40">20:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="41">20:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="42">21:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="43">21:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="44">22:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="45">22:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="46">23:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="47">23:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t   </select>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t  \t</tr>\r\n\t\t\t\t\t\t\t\t\t\t\t</table>\t\r\n\t\t\t\t\t\t\t    \t  \t</td>\t    \t  \t\r\n\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t</table>\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t</tr> \t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t'),
j+=" \r\n\t\t\t\t";j+="\r\n\t\t\t"}j+="\r\n\t\t"}return j+='\t\r\n\t</table>\r\n</div>\r\n<div align="center" valign="middle" width="25" style="float:right;">\r\n\t<a href="#" onclick="return false;">\r\n\t\t<img src="'+(null==(c=g.baseUrl)?"":_.escape(c))+'images/delete_icon_15.png" class="remove" title="'+(null==(c=g.i18n("DELETE_TAG"))?"":_.escape(c))+'" width="15" height="15"/>\r\n\t</a>\r\n</div>'}});
define("component/actionbuttons/UploadNewVersionButton","component/actionbuttons/AbstractButton Template tpl!component/actionbuttons/InlineUploadNewVersionBlock jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils utils/WCEvent".split(" "),function(g,c,j,a,h,k,e,b,d){var l=function(d,a,b,e){this.isExpanded=!1;this.rowCtx=null;this.currentUser=b;this.currentUser||(this.currentUser=gCurrentUser);e&&(this.useInlineForm=e.useInlineForm);this.useInlineForm?
(this.t=new c(k,j),this.t.d.formdata={},this.t.bind("click","img.remove",this.clearRow,this),this.t.bind("change",".datafield",h.bind(this.storeFormData,this))):this.t={d:{}};e&&(e.alwaysUpdateAllProjects&&(this.t.d.alwaysUpdateAllProjects=!0),this.useInlineForm=e.useInlineForm,this.t.d.idprefix=e.uniqueIdPrefix?e.uniqueIdPrefix:"");g.call(this,d,a)};l.prototype=Object.create(g.prototype);l.prototype.constructor=l;l.prototype.loadDocumentInfo=function(){if(this.docVerId){var d=e.getInstance().getDocInfoWithThumbnail(this.docVerId),
b=null;this.useInlineForm&&(b=e.getInstance().getGlobalDocumentSettings());a.when(b,d).done(h.bind(function(d,a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var b=0;b<this.afterLoadCallbacks.length;b++)this.afterLoadCallbacks[b]();this.afterLoadCallbacks=[]}},this))}};l.prototype.render=function(){this.renderBtn(this.btnCtx);this.isExpanded&&this.rowCtx&&(this.t.render(),this.fileField&&this.rowCtx.find("input[name^=newVersionDocFile_]").replaceWith(this.fileField),
this.t.d.duePeriod&&this.rowCtx.find("select[name^=due_periodOfDay]").val(this.t.d.duePeriod))};l.prototype._renderBtnImpl=function(d){var b=a('<img src="'+this.baseUrl+'images/round_button_upload.png" />');b.attr("alt",k.t("DOCDETAILSCHECKIN_TAG"));b.attr("title",k.t("DOCDETAILSCHECKIN_TAG"));b.addClass("actionBtn");var c=a('<a href="#"></a>');c.append(b);c.click(h.bind(function(){this.btnClicked();return!1},this));d.append(c)};l.prototype.btnClicked=function(){if(this.useInlineForm)this.isExpanded=
!0,this.render(),d.emit("btnClicked.UploadNewVersion."+this.docVerId);else{var a=b.getMenuFileParamValue(),a=window.open(this.baseUrl+"dodocdetailsactions.jsp?actionVal=DirectCheckinDoc&docVerID="+this.docVerId+"&menu_file="+a,"_blank");null!=a&&a.focus()}};l.prototype.clearRow=function(){this.rowCtx.empty();this.isExpanded=!1};l.prototype.revisionLetters="ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");l.prototype.getRevisionLetter=function(d){var a="";if(d&&!isNaN(d)){for(;d>this.revisionLetters.length;)a+=
this.revisionLetters[this.revisionLetters.length-1],d-=this.revisionLetters.length;0<d&&(a+=this.revisionLetters[d-1])}else a+=this.revisionLetters[0];return a};l.prototype.setRowContext=function(d){this.rowCtx=d;this.t.setContext(d);this.render()};l.prototype.storeFormData=function(){this.fileField=this.rowCtx.find("input[name^=newVersionDocFile_]");this.t.d.formdata.newVersionDocDesc=this.rowCtx.find("input[name^=newVersionDocDesc_]").val();this.t.d.incrementRevision="checked"==this.rowCtx.find("input[name^=incrementRevision_]").attr("checked");
this.t.d.updateAllProjects="checked"==this.rowCtx.find("input[name^=updateAllProjects_]").attr("checked");this.t.d.AppCycleFlag="checked"==this.rowCtx.find("input[name^=AppCycleFlag]").attr("checked");this.t.d.dueDate=this.rowCtx.find("input[name^=longFormat_due_date]").val();this.t.d.dueDateH1=this.rowCtx.find("input[name^=due_date]").val();this.t.d.dueDateH2=this.rowCtx.find("input[name^=save_due_date]").val();this.t.d.duePeriod=this.rowCtx.find("select[name^=due_periodOfDay]").val()};l.prototype.updateDocumentInfo=
function(d,a){this.t.d.docVerId=this.docVerId;this.t.d.docId=d.docID;this.t.d.docName=d.docName;this.t.d.projectList=d.projList;var b=null;try{b=parseInt(d.docRevIdx)}catch(c){b=0}this.t.d.lastRevision=this.getRevisionLetter(b+1);d.appStatus&&(this.t.d.approvalCycleState=d.appStatus.cycleStatusStringCode);this.t.d.showDueDate=d.userPerms.changeApp?"1":"0";if(!d.docIsUrl&&!("00001_0000000014"==d.docTypeID&&d.docSourceId)&&(!d.docCheckedOutOwner||d.docCheckedOutOwner==this.currentUser.userID)&&(d.userPerms.isProjMgr||
d.userPerms.checkout))this.isVisible=!0;a&&(b=a.approvalRestartOption,this.t.d.initialStartApprovalValue="1"==b?!0:"2"==b?!1:"cycle_started"==a.approvalCycleState||"cycle_finished"==a.approvalCycleState?!0:!1,this.t.d.allowRaiseRevision="1"==a.allowRaiseRevision,this.t.d.approvalRestartEnableCheckbox=a.approvalRestartUploaderCanOverrule);this.t.d.baseUrl=this.baseUrl};l.prototype.validate=function(){var d=[];if(this.isExpanded){var f=this.rowCtx.find("input[name^=newVersionDocFile_]"),c=f.val();c?
b.getFileExtension(c)!=b.getFileExtension(this.t.d.docName)&&(f={isBlocking:!0,msg:k.t("BADCHECKINEXT"),element:f},d.push(f)):(f={isBlocking:!0,msg:k.t("DocRowFileNotChosen"),element:f},d.push(f));f=this.rowCtx.find("input[name^=newVersionDocDesc_]");a.trim(f.val())||(f={isBlocking:!0,msg:k.t("DOCDETAILSCHECKINCOMMENT_TAG"),element:f},d.push(f))}return d};l.wcrinit=function(d){var b=a(d).attr("data-docverid"),c=a(d).attr("data-inlinectx"),e=a(d).attr("data-inline");(new l(b,a(d),window.gCurrentUser,
{useInlineForm:"true"==e})).setRowContext(a("#"+c))};return l});
define("component/actionbuttons/ViewButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/DocTableXUtils doctablex/AJAXDataCache".split(" "),function(g,c,j,a,h){var k=function(a,b){g.call(this,a,b)};k.prototype=Object.create(g.prototype);k.prototype.constructor=k;k.prototype._renderBtnImpl=function(e){var b=c('<img src="'+this.baseUrl+'images/viewmag.png" />');b.attr("alt",a.t("CLICK_HERE_TO_VIEW"));b.attr("title",a.t("CLICK_HERE_TO_VIEW"));b.addClass("actionBtn");
var d=c("<a></a>");d.attr("href","#");d.append(b);d.click(j.bind(function(){this.openViewer();return!1},this));e.append(d)};k.prototype.openViewer=function(){var a=h.getMenuFileParamValue(),b=h.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"viewdocument.jsp?docVerID="+this.docVerId+"&menu_file="+a+"&pageIndex=0&sourcePage="+b)};k.prototype.updateDocumentInfo=function(a){this.isVisible=a.userPerms.view&&!a.docIsUrl};k.wcrinit=function(a){var b=c(a).attr("data-docverid");new k(b,c(a))};return k});
define("component/actionbuttons/DownloadButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,a,h,k){var e=function(a,d){this.downloadType="none";g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(b){var d=c('<img src="'+this.baseUrl+'images/round_button_download.png" />');d.attr("alt",a.t("DOWNLOAD"));d.attr("title",
a.t("DOWNLOAD"));d.addClass("actionBtn");var e=j.bind(function(){"pespective"==this.downloadType?this.showDownloadPerspectives():"locked"==this.downloadType?confirm(a.t("CHECKED_OUT_DOWNLOAD_WARNING"))&&this.downloadDocument():(this.downloadType="download")&&this.downloadDocument();return!1},this),i=c('<a href="#"></a>');i.click(e);i.append(d);b.append(i)};e.prototype.downloadDocument=function(){var a=k.getSourcePageURLEncoded();window.location=this.baseUrl+"doprojectdocsactions.jsp?actionVal=DownloadDoc&actionDocVerID="+
this.docVerId+"&projectID="+this.projectId+"&sourcePage="+a};e.prototype.showDownloadPerspectives=function(){var b=h.getInstance().getDocDownloadPerspectives(this.docVerId,this.docTypeId);c.when(b).done(j.bind(function(d){if(null==d)alert(a.t("UNABLETOGETFORMATSFORDOWNLOAD"));else if(0==d.length)alert(a.t("NOFORMATSFORFILETYPE"));else{this.popupContent=c("<div />");for(var b=0;b<d.length;b++){var e=d[b].name,f=d[b].longName;"Native"===e&&(e=a.t("NATIVE_PERSPECTIVE_NAME"),f="");var g=c('<input type="radio" name="selectedDownloadFormat"/>');
g.val(f);this.popupContent.append(g).append("&nbsp;"+e+"<br/>")}this.showDialog()}},this))};e.prototype.showDialog=function(){if(this.popupContent){var b={};b[a.t("CLOSE")]=j.bind(function(){this.popupContent.dialog("close")},this);b[a.t("DOWNLOAD")]=j.bind(function(){this.downloadPerspective()&&this.popupContent.dialog("close")},this);this.popupContent.dialog({autoOpen:!1,dialogClass:"no-close",modal:!0,title:a.t("SELFORMAT_NOTREDUNDANT"),position:"center",buttons:b}).dialog("open")}};e.prototype.downloadPerspective=
function(){var b=this.popupContent.find("input:checked");if(1!=b.length)return alert(a.t("ONEFORMATHASTOBESELECTEDTOPERFORMDOWNLOAD")),!1;window.location=this.baseUrl+"dodocdetailsactions.jsp?actionVal=DoDownloadPerspective&docVerID="+this.docVerId+"&perspectiveName="+b.val();return!0};e.prototype.updateDocumentInfo=function(a){this.docTypeId=a.docTypeID;0<a.projList.length&&(this.projectId=a.projList[0].id);a.userPerms.download&&!a.docIsUrl&&(this.downloadType="00001_0000000001"==a.docTypeID||"00001_0000000002"==
a.docTypeID||"00001_0000000018"==a.docTypeID?"pespective":a.docCheckedOutOwner?"locked":"download");this.isVisible="none"!=this.downloadType};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};return e});
define("component/actionbuttons/Open3DButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,a,h,k){var e=function(a,d){g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(b){var d=c('<img src="'+this.baseUrl+'images/view3d.png" />');d.attr("alt",a.t("CLICK_HERE_TO_VIEW_3D"));d.attr("title",a.t("CLICK_HERE_TO_VIEW_3D"));
d.addClass("actionBtn");var e=j.bind(function(){this.openDocument3D();return!1},this),i=c('<a href="#"></a>');i.click(e);i.append(d);b.append(i)};e.prototype.openDocument3D=function(){var a=k.getMenuFileParamValue(),d=k.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"doctypecolladaview.jsp?docVerID="+this.docVerId+"&menu_file="+a+"&sourcePage="+d)};e.prototype.updateDocumentInfo=function(a){this.isVisible="1"==a.has3dView};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};
return e});
define("component/actionbuttons/OpenACADButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(g,c,j,a,h,k){var e=function(a,d){g.call(this,a,d)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype.loadDocumentInfo=function(){if(this.docVerId){var a=h.getInstance().getGlobalDocumentSettings(),d=h.getInstance().getDocInfoWithThumbnail(this.docVerId);c.when(a,d).done(j.bind(function(d,
a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var b=0;b<this.afterLoadCallbacks.length;b++)this.afterLoadCallbacks[b]();this.afterLoadCallbacks=[]}},this))}};e.prototype._renderBtnImpl=function(b){var d=c('<img src="'+this.baseUrl+'images/open_acad.png" />');d.attr("alt",a.t("DOCOPENINACAD"));d.attr("title",a.t("DOCOPENINACAD"));d.addClass("actionBtn");var e="",i=j.bind(function(){if("Standard"===this.openType){var d=k.getMenuFileParamValue();
e=this.baseUrl+"doctypeotherview.jsp?docVerID="+this.docVerId+"&menu_file="+d}else"Enterprise"===this.openType&&(e=encodeURI("acade:@"+this.projectName+":"+this.docName));j.defer(function(){window.location=e});return!1},this),f=c('<a href="#"></a>');f.click(i);f.append(d);b.append(f)};e.prototype.updateDocumentInfo=function(a,d){this.docName=a.docName;0<a.projList.length&&(this.projectName=a.projList[0].name);if(a.userPerms.download&&("00001_0000000001"==a.docTypeID||"00001_0000000002"==a.docTypeID||
"00001_0000000003"==a.docTypeID))this.openType=d.openCadType;this.isVisible=this.openType&&"None"!==this.openType};e.wcrinit=function(a){var d=c(a).attr("data-docverid");new e(d,c(a))};return e});
define("doctablex/StaticDocumentRowView","doctablex/DocTableXUtils utils/WCEvent wcr/webcenter_xml wcr/webcenter_html jquery wcr/ObjectArrayCloneUtil component/actionbuttons/UploadNewVersionButton component/actionbuttons/ViewButton component/actionbuttons/DownloadButton component/actionbuttons/Open3DButton component/actionbuttons/OpenACADButton utils/webi18n!DocRefStrings wcr/extpopup wcr/approvalInfoPopup".split(" "),function(g,c,j,a,h,k,e,b,d,l,i,f){var n=function(d,a,b){if(!d&&!a&&!b)return this;
this.dm=d;if(!this.dm)return alert("Cannot initialized view without data model."),null;this.phElemID=a;this.rowIndex=-1;this.renderOptions=b;this.renderOptions||(this.renderOptions=this.dm.renderOptions);this.supportAdvancedThumb=b.supportAdvancedThumb;!this.supportAdvancedThumb&&!1!==this.supportAdvancedThumb&&(this.supportAdvancedThumb=!1,this.constructor==n.prototype.constructor&&(this.supportAdvancedThumb=!0));this.itemRootElemStr=this.renderOptions.itemRootElemStr||"td";this.renderMethodMap=
{AttributeFlapout:this.renderExpandCollapseButton,UpDownArrows:this.renderSortingArrows,SequenceNumber:this.renderSequenceNumber,DocumentName:this.renderDocumentSpec,DocumentActions:this.renderDocumentActions,DocumentProperty_Thumbnail:this.renderThumbnail,DocumentProperty_Description:this.renderDocumentDescription,DocumentProperty_ApprovalStatus:this.renderApprovalStatus,DocumentProperty_ApprovalStage:this.renderApprovalStage,DocumentProperty_Project:this.renderDocProjectName,DocumentProperty_VersionRevision:this.renderDocumentVersion,
DocumentProperty_VersionAuthor:this.renderDocumentAuthor,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDate,ReferenceProperty:this.renderReferenceProperty,DocumentAttribute:this.renderDocAttribute,LocalRemote:this.renderLocalRemoteButton,DeleteButton:this.renderDeleteButton};this._newVersionCell=this._newVersionRow=this.newVersionBtn=this.openAcadBtn=this.open3dBtn=this.downloadBtn=this.viewBtn=null;return this};n.prototype.render=function(d){var a=h("#"+this.phElemID);if(0==a.length)return a;
var b=this.renderOptions;d&&(this.renderOptions=d);this.rowIndex=this.dm.getIndexInTable();"list"==this.renderOptions.renderMethod?this.renderSimple(a):"table"==this.renderOptions.renderMethod?this.renderComplex(a):alert("Not supported render method: "+this.renderOptions.renderMethod+".");this.renderOptions=b;this.renderOptions.styleObj&&a.find("*").not(".darktext_greenlink_12_bold").not(".darktext_greenlink_11").css(this.renderOptions.styleObj);return a};n.prototype.repaintRow=function(){this.renderOptions.isRepaintRow=
!0;this.render();this.renderOptions.isRepaintRow=!1};n.prototype.renderSimple=function(d){if(!d||0==d.length)return d;try{if(d.html(""),this.renderDocAttrCatAndRefPropsPlaceholder(d),this.renderNewVersionPlaceholder(d),this.renderSortingArrows(d),this.renderThumbnail(d,{thumbnailSize:50}),this.renderDocumentSpec(d),this.renderDeleteButton(d),!this.dm.getParentDocTable().allowMultiple&&this.constructor==n){var a="<"+this.itemRootElemStr+' class="darktext_greenlink_11">',b=this.dm.getParentDocTable().view,
a=a+b.renderGreenLinksPlaceholder("inline"),a=a+("</"+this.itemRootElemStr+">");if(0<h(a).appendTo(d).length){var c=this.dm.getParentDocTable(),f=c.getDocumentSourceOptions(c.greenLinksPrefix+"_inline");c.dshObj.displayLinks(f)}}}catch(e){return g.log("Problem in StaticDocumentRowView.renderSimple:\n"+e),null}return d};n.prototype.renderComplex=function(d){if(!d||0==d.length)return d;try{d.html("");this.renderDocAttrCatAndRefPropsPlaceholder(d);this.renderNewVersionPlaceholder(d);var a=this.renderOptions.columns;
if(a)for(var b=0;b<a.length;b++){var c=this.renderOptions.columns[b];if(c){var f=c.type;"DocumentProperty"==f&&(f+="_"+c.typeDetail);var e=this.renderMethodMap[f];e&&e.call(this,d,c)}}var i=d.find(">td").size()-1;h("#"+this.dm.aCatRowID+" > td.attrCategoryColumn").attr("colspan",i)}catch(l){return g.log("Problem in StaticDocumentRowView.renderComplex:\n"+l),null}return d};n.prototype.renderExpandCollapseButton=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus())var b=
this.dm.getThisInDOM()+".expandClicked(this); return false;",c=this.dm.hasAttrCat()?"":" hiddenElement",a=a+('<a class="btn btn16 expandCollapseButton '+c+'" href="#" onclick="'+b+'">'),a=this.dm.dependsOnItself?a+('<i class="cycle" title="'+j.xmlencode(f.t("DocRowCyclicDepTooltip"))+'"></i>'):this.dm.aCatExpanded?a+('<i class="collapse" title="'+j.xmlencode(f.t("DocRowCollapseTooltip"))+'"></i>'):a+('<i class="expand" title="'+j.xmlencode(f.t("DocRowExpandTooltip"))+'"></i>'),a=a+"</a>";a+="</"+
this.itemRootElemStr+">";d.append(a)}catch(e){g.log("Problem in StaticDocumentRowView.renderExpandCollapseButton:\n"+e)}};n.prototype.renderSortingArrows=function(d){try{var a="";if(this.dm.isEditable){var a=a+("<"+this.itemRootElemStr+">"),b=this.dm.getParentInDOM()+".moveUpButtonClicked("+this.rowIndex+");return false;",c=this.dm.getParentInDOM()+".moveDownButtonClicked("+this.rowIndex+");return false;",f=0==this.rowIndex,e=this.rowIndex==this.dm.getParentDocTable().getNumberOfRows()-1;f&&!e?a+=
'<a class="btn btn9x14 float-right" href="#" onclick="'+c+'"><i class="sort-down"></i></a>':e&&!f?a+='<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-up"></i></a>':!f&&!e&&(a+='<div class="float-right">',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-asc"></i></a><br/>',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+c+'"><i class="sort-desc"></i></a>',a+="</div>");a+="</"+this.itemRootElemStr+">"}d.append(a)}catch(i){g.log("Problem in StaticDocumentRowView.renderSortingArrows:\n"+
i)}};n.prototype.renderSequenceNumber=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+("<span>"+(this.rowIndex+1)+"</span>"),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(b){g.log("Problem in StaticDocumentRowView.renderSequenceNumber:\n"+b)}};n.prototype.renderThumbnail=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">");if(!this.dm.isInErrorStatus())var c=this.dm.thumbnailURL,b=c&&0<c.length?b+this.customThumbnailHTML(c,a.thumbnailSize):b+'<div class="thumb"></div>';
b+="</"+this.itemRootElemStr+">";d.append(b)}catch(f){g.log("Problem in StaticDocumentRowView.renderThumbnail:\n"+f)}};n.prototype.renderDocumentSpec=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);if(this.dm.isInErrorStatus()){b+='<span class="brokenDocRef">';this.dm.docName&&(b+=j.xmlencode(this.dm.docName)+"&nbsp;&nbsp;");var c=j.xmlencode(f.t("DocRowCannotLoadDoc")),b=b+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/warning.gif" title="'+
c+'"/>'),b=b+"</span>"}else b+='<a class="docrefdoclink" href="'+window.webcenterConfig.jspBaseUrl+"docdetails.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(this.dm.docName),b+="</a>",this.dm.docCheckedOutOwner&&(b+='&nbsp;<img border="0" style="vertical-align:bottom" title="'+j.xmlencode(f.t("DOC_CHECKED_OUT"))+'" alt="'+j.xmlencode(f.t("DOC_CHECKED_OUT"))+'" src="images/locked_on_white.gif">');b+="</"+this.itemRootElemStr+">";d.append(b)}catch(e){g.log("Problem in StaticDocumentRowView.renderDocumentSpec:\n"+
e)}};n.prototype.renderDocumentActions=function(d,a){var b;b=""+("<"+this.itemRootElemStr+' class="docrefactionscol">');if(!this.dm.isInErrorStatus())for(var c=a.typeDetail.split("|"),f=0;f<c.length;f++){var e=c[f],i=this.phElemID+"_actionBtn_"+g.getNextUniquePrefix();b+='<span id="'+i+'" />';var l=null;switch(e){case "View":l=this.getViewBtn();break;case "Open3d":l=this.getOpen3DBtn();break;case "OpenAcad":l=this.getOpenACADBtn();break;case "Download":l=this.getDownloadBtn();break;case "UploadNewVersion":l=
this.getUploadNewVersionBtn()}l&&_.defer(_.bind(function(d,a){a.renderBtn(h("#"+d))},this,i,l))}b+="</"+this.itemRootElemStr+">";d.append(b)};n.prototype.renderDocumentDescription=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);this.dm.isInErrorStatus()||this.dm.docDesc&&(b+="<span>"+j.xmlencode(this.dm.docDesc)+"</span>");b+="</"+this.itemRootElemStr+">";d.append(b)}catch(c){g.log("Problem in StaticDocumentRowView.renderDocumentDescription:\n"+c)}};n.prototype.renderApprovalStatus=
function(d,b){try{var c="",c=c+("<"+this.itemRootElemStr+"  >"),c=c+this.renderInlineLabel(b);if(!this.dm.isInErrorStatus()){var e=this.dm.appStatus;if(e&&e.cycleStatus){for(var i=null,l=this.dm.appTypeList,h=0;h<l.length;h++){var k=l[h];if(k.id==e.statusID){i=k;break}}var n="onclick=\"javascript:showapprovaldetails(this, event,'"+this.dm.docVerID+"', 'Approval Setup "+j.xmlencode(a.encodeForJScript(this.dm.docName))+"')\"",n=n+' onmouseout="javascript:delayhidemenu();"',c=c+'<div class="docrefApprovalStatus">';
if("Not Started"==e.cycleStatus)var v=j.xmlencode(f.t("APPROVAL_STATUS_HOLD")),c=c+('<img border="0" src="images/stopped-approval.png" alt="'+v+'" title="'+v+'" '+n+" />");else i&&(v=j.xmlencode(i.translName),c+='<img border="0" src="images/'+i.icon+'" alt="'+v+'" title="'+v+'" '+n+"/>");c+="</div>";c+="</div>"}}c+="</"+this.itemRootElemStr+">";d.append(c)}catch(A){g.log("Problem in StaticDocumentRowView.renderApprovalStatus:\n"+A)}};n.prototype.renderApprovalStage=function(d,a){try{var b="",b=b+
("<"+this.itemRootElemStr+' class="docrefApprovalStage" >'),b=b+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var c=this.dm.appStatus;c&&c.stageName&&(b+=j.xmlencode(c.stageName))}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(f){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+f)}};n.prototype.renderDocProjectName=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var c=this.dm.projects;if(c&&0<
c.length)for(var f=0;f<c.length;f++){var e=c[f];e&&(e.id&&e.name)&&(0<f&&(b+="<br/>"),b+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+e.id+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(e.name),b+="</a>")}else this.dm.project.id&&this.dm.project.name&&(b+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+this.dm.project.id+"&amp;menu_file="+g.getMenuFileParamValue()+'" target="_blank">',b+=j.xmlencode(this.dm.project.name),
b+="</a>")}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(i){g.log("Problem in StaticDocumentRowView.renderDocProjectName:\n"+i)}};n.prototype.renderDocumentVersion=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+' class="center">'),b=b+this.renderInlineLabel(a);this.dm.isInErrorStatus()||(this.dm.docVerIdx&&(b+=this.dm.docVerIdx,this.dm.docRevLetter&&(b+="("+this.dm.docRevLetter+")")),a.uploadNewVersion&&(b+='&nbsp;&nbsp;<span id="'+this.phElemID+'_uploadNewVersionBtn" />',_.defer(_.bind(function(){var d=
this.getUploadNewVersionBtn();d&&d.setBtnContext(h("#"+this.phElemID+"_uploadNewVersionBtn"))},this))));b+="</"+this.itemRootElemStr+">";d.append(b)}catch(c){g.log("Problem in StaticDocumentRowView.renderDocumentVersion:\n"+c)}};n.prototype.renderDocumentAuthor=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+' class="Black_11">'),b=b+this.renderInlineLabel(a);!this.dm.isInErrorStatus()&&this.dm.docAuthor&&(b+='<a class="docrefdoclink" href="#" onclick="javascript:ShowUserDetails(\''+this.dm.docAuthor.id+
"');return false;\">",b+=j.xmlencode(this.dm.docAuthor.fullName),b+="</a>");b+="</"+this.itemRootElemStr+">";d.append(b)}catch(c){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+c)}};n.prototype.renderDocumentModifiedDate=function(d,b){try{var c="",c=c+("<"+this.itemRootElemStr+' class="center">'),c=c+this.renderInlineLabel(b);this.dm.isInErrorStatus()||this.dm.modDate&&(c+=j.xmlencode(a.getDateHourString(this.dm.modDate)));c+="</"+this.itemRootElemStr+">";d.append(c)}catch(f){g.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+
f)}};n.prototype.renderLocalRemoteButton=function(d,a){try{var b="",b=b+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus()&&this.dm.getParentDocTable().hasLocalRemoteButton()&&this.dm.isRemoteDocument()){var c="",e=j.xmlencode(f.t("DocRowLocalRemoteInfoTooltip")),i="docref_info_external.png";this.dm.isEditable&&(this.dm.canUserAddDocuments()&&"ReadOnly"!=a.visibility&&!this.dm.dependsOnItself)&&(c="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+
");",e=j.xmlencode(f.t("DocRowLocalRemoteButtonTooltip")),i="docref_make_internal.png");b+='<img border="0" src="'+window.webcenterConfig.jspBaseUrl+"images/"+i+'"';b+=' title="'+e+'" onclick="'+c+'"/>'}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(l){g.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+l)}};n.prototype.renderDeleteButton=function(d){try{var a="";if(this.dm.isEditable)var b="javascript: "+this.dm.getParentInDOM()+".deleteButtonClicked("+this.rowIndex+");return false;",
a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+('<a class="btn btn15" href="#" onclick="'+b+'"><i class="remove"></i></a>'),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(c){g.log("Problem in StaticDocumentRowView.renderDeleteButton:\n"+c)}};n.prototype.renderReferenceProperty=function(d,a){this._renderDocAttrRefPropValue(d,a,!0)};n.prototype.renderDocAttribute=function(d,a){this.dm.isInErrorStatus()||this.dm.dependsOnItself?d.append("<"+this.itemRootElemStr+"/>"):this._renderDocAttrRefPropValue(d,
a,!1)};n.prototype._renderDocAttrRefPropValue=function(d,a,b){try{var c=!1,e=a.typeDetail,i=b?this.dm.propsACatObj:this.dm.aCatObj;if(e&&i&&i.loaded){var l=i.findAttribute(e,a.attributeName);if(l&&!l.isRichText()){var k=i.findCell(l);if(k){var n=k.cellObj,v=k.row,A=k.col,z="ReadOnly"!=a.visibility,z=b?z&&this.dm.canUserEditProperties():z&&this.dm.canUserEditAttributes(),C=b?this.dm.propsACatPrefix:this.dm.aCatPrefix,e=C+"td_"+v+"_"+A,B=h("#"+e);if(1==B.length){var k='<span class="docRefInfo">',u=
j.xmlencode(f.t("DocRowAttributeInColumnInfo")+": "+a.label),k=k+('<img border="0" src="images/doc_ref_info.png" title="'+u+'"/>'),k=k+"</span>";B.removeAttr("id");B.html(k)}else 1<B.length&&alert("More than one HTML element with ID '"+e+"' on the page!");var q="<"+this.itemRootElemStr+' id="'+e+'" class="'+(b?"referencePropertyCell":"documentAttributeCell")+'">',q=q+this.renderInlineLabel(a);l.isDocReference()?l.valueHyperlink&&(q+=l.valueHyperlink.replace(/ \| /g,"<br/>")):q+=i.renderAttributeValueInternal(n,
l,v,A,a.visibility,z);q+="</"+this.itemRootElemStr+">";d.append(q);z&&l.type&&"datetime"==l.type.toLowerCase()&&i.createCalendar("#"+C+"longFormat_adate"+l.id,"#"+C+"date_period_of_day_"+l.id);c=!0}}}c||(q="<"+this.itemRootElemStr+">",q+=this.renderInlineLabel(a),i&&i.loaded?(q+='<span class="brokenDocRef">',u=j.xmlencode(b?f.t("DocRowCannotFindProperty"):f.t("DocRowCannotFindAttribute")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"):!b&&this.dm.hasNoAttrCat()&&(q+='<span class="brokenDocRef">',
u=j.xmlencode(f.t("DocRowNoAttrCategoryInfo")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"),q+="</"+this.itemRootElemStr+">",d.append(q))}catch(D){g.log("Problem in StaticDocumentRowView.renderReferenceProperty "+a.label+":\n"+D)}};n.prototype.renderDocAttrCatAndRefPropsPlaceholder=function(d){try{if(!this.renderOptions.isRepaintRow){this.dm.destroyACatObj();h("#"+this.dm.aCatRowID).remove();var a="",b=this.renderOptions.columns,a=a+('<tr id="'+this.dm.aCatRowID+'" class="hiddenElement">'),
a=a+"<td></td>",a=a+'<td class="attrCategoryColumn">';null!=g.getRenderItem(b,"ReferenceProperty")&&(a+='<div id="'+this.dm.propsACatElemID+'" class="hiddenElement"></div>');if(!this.aCatExpandDisabled||null!=g.getRenderItem(b,"DocumentAttribute"))a+='<div id="'+this.dm.aCatElemID+'"></div>';var a=a+"</td>",c=h(a+"</tr>");this.renderOptions.styleObj&&c.css(this.renderOptions.styleObj);d.after(c)}}catch(f){g.log("Problem in StaticDocumentRowView.renderDocAttrCatAndRefPropsPlaceholder:\n"+f)}};n.prototype.renderNewVersionPlaceholder=
function(d){this.renderOptions.isRepaintRow||(this._newVersionRow&&this._newVersionRow.remove(),this._newVersionRow=h('<tr id="'+this.phElemID+'_newVersionRow"></tr>'),d.after(this._newVersionRow),this._newVersionCell=h("<td colspan="+(this.renderOptions.columns?this.renderOptions.columns.length:1)+' style="padding: 0px 10px">'),this._newVersionRow.append(this._newVersionCell),this.newVersionBtn&&this.newVersionBtn.setRowContext(this._newVersionCell),this.renderOptions.styleObj&&this._newVersionRow.find("*").css(this.renderOptions.styleObj))};
n.prototype.customThumbnailHTML=function(d,b){var c="";if(!b||"0"==b)b="50";if(this.supportAdvancedThumb&&this.dm.docVerID)var f=window.webcenterConfig.jspBaseUrl+"DownloadViewerThumbnail.jsp?docversionid="+this.dm.docVerID+"&amp;pix=500&amp;ajax=1",e=this.dm.docDesc?this.dm.docDesc:"",i=window.webcenterConfig.jspBaseUrl+"viewdocument.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+g.getMenuFileParamValue()+"&amp;sourcePage="+g.getSourcePageURLEncoded(),c=c+('<a href="'+i+'" target="_blank">')+
'<img onmouseout="delayhidethumb();"',c=c+(" onmouseover=\"showthumb(event, '"+d+"', '"+j.xmlencode(a.encodeForJScript(this.dm.docName))+"', 202, null, '"+f+"', 500);\""),c=c+(' src="'+window.webcenterConfig.jspBaseUrl+d+'"'),c=c+(' alt="'+j.xmlencode(e)+'" width="'+b+'px" height="'+b+'px" border="0" align="middle">'),c=c+"</a>";else c+='<img src="'+window.webcenterConfig.jspBaseUrl+d+'"',c+=' width="'+b+'px" height="'+b+'px" border="0" align="middle">';return c};n.prototype.renderInlineLabel=function(d){var a=
"";this.renderOptions.hideHeader&&(d&&d.label)&&(a+='<div class="docrefinlinelabel">'+g.getEncodedTranslatedLabel(d.label),"Required"==d.visibility&&(a+='&nbsp;<font color="red">*</font>'),a+="</div>");return a};n.prototype.getUploadNewVersionBtn=function(){if(!this.newVersionBtn&&this.showAdvancedDocumentActions()&&this.dm.canUserUploadNewVersion()){var d={useInlineForm:!0,alwaysUpdateAllProjects:!0,uniqueIdPrefix:g.getNextUniquePrefix()+"_"};this.newVersionBtn=new e(this.dm.docVerID,null,this.dm.parentDocTable.currentUser,
d);c.on("btnClicked.UploadNewVersion."+this.dm.docVerID,this.dm.setIsChanged.bind(this.dm));this._newVersionCell&&this.newVersionBtn.setRowContext(this._newVersionCell)}return this.newVersionBtn};n.prototype.getViewBtn=function(){this.viewBtn||(this.viewBtn=new b(this.dm.docVerID));return this.viewBtn};n.prototype.getDownloadBtn=function(){this.downloadBtn||(this.downloadBtn=new d(this.dm.docVerID));return this.downloadBtn};n.prototype.getOpen3DBtn=function(){this.open3dBtn||(this.open3dBtn=new l(this.dm.docVerID));
return this.open3dBtn};n.prototype.getOpenACADBtn=function(){this.openAcadBtn||(this.openAcadBtn=new i(this.dm.docVerID));return this.openAcadBtn};n.prototype.showAdvancedDocumentActions=function(){return!0};return n});
define("doctablex/StaticDocumentRow","doctablex/DocTableXUtils doctablex/StaticDocumentRowView doctablex/AJAXDataCache utils/webi18n!DocRefStrings wcr/ObjectArrayCloneUtil wcr/webcenter_xml jquery".split(" "),function(g,c,j,a,h,k,e){var b=function(d){if(!d)return this;this.setStatus("init");this.rowID=d.origDocRow?d.origDocRow.rowID:g.getNextUniquePrefix();if(this.parentDocTable=d.parentDocTable){this.prefix=this.getParentDocTable().getTablePrefix()+"_"+this.rowID;this.isChanged=!1;this.isEditable=
this.getParentDocTable().isEditable;"undefined"!=typeof d.isEditable&&(this.isEditable=!0===d.isEditable);this.aCatNotExpandedYet=!0;this.dependsOnItself=!1;this.renderOptions=d.renderOptions;this.renderOptions||(this.renderOptions=this.getParentDocTable().renderOptions);this.renderOptions||(this.renderOptions={});this.drID=d.drID;this.docVerID=d.docVerID;this.docID=d.docID;this.docName=d.docName;this.docDesc=d.docDesc;this.docVerIdx=d.docVerIdx;this.latestDocVerIdx=d.latestDocVerIdx;this.docRevLetter=
d.docRevLetter;this.appStatus=d.appStatus;this.thumbnailURL=d.thumbnailURL;this.docAuthor=d.docVerAuthor;this.modDate=d.modDate;this.appTypeList=d.appTypeList;this.userPerms=d.userPerms||{};this.docCheckedOutOwner=this.docType=this.docTypeID=null;this.project={id:d.projectID||null,name:d.projectID?d.projectName:null,isTemplate:d.isInTemplate||null};this.projects=d.projects||[];var a=[],e=this.renderOptions.columns;if(e)for(var f=0;f<e.length;f++){var h=e[f];if(h&&h.type&&"ReferenceProperty"==h.type){var j=
h.typeDetail,k=this.findPropertyByID(j,d.properties);k?(k.name=h.label,k.isRequired="Required"==h.visibility):k={id:j,name:h.label,isRequired:"Required"==h.visibility,value:""};a.push(k)}}this.props=a;this.propsValuesInitialized=!1;a=g.getRenderItem(this.renderOptions.columns,"AttributeFlapout");this.aCatExpandDisabled=!a;this.aCatExpanded=d.aCatExpanded||!1;this.aCatView=this.getParentDocTable().aCatView;a&&a.typeDetail&&(this.aCatView=a.typeDetail);this.aCatPrefix=this.getRowPrefix()+"_ACat_";this.aCatRowID=
this.getRowPrefix()+"_ACatRow";this.aCatElemID=this.getRowPrefix()+"_ACatPanel";this.aCatID=d.aCatID||null;this.aCatObj=null;this.renderedAttrCat={id:"",isEditable:!1};this.isExpandedAttrsEditable=!0;a&&(this.isExpandedAttrsEditable="Editable"==a.visibility);this.propsACatPrefix=this.getRowPrefix()+"_PropsACat_";this.propsACatElemID=this.getRowPrefix()+"_PropsACatID";this.propsACatID=this.getParentDocTable().propsACatID;this.propsACatObj=null;this.view=new (d.viewClass||c)(this,this.getRowPrefix(),
this.renderOptions);this.constructor==b.prototype.constructor&&this.updateDocInfoFromServer(!0);return this}alert("StaticDocumentRow cannot be initialized without parent table reference!")};b.prototype.setCustomView=function(d,a){d&&(this.view=d,this.view.dm=this,this.view.phElemID||(this.view.phElemID=this.getRowPrefix()),a&&this.displayRow())};b.prototype.setIsEditable=function(a){void 0!==a&&a!=this.isEditable&&(this.isEditable=a)};b.prototype.isInactive=function(){return this.getParentDocTable().isInactive};
b.prototype.displayRow=function(a){this.view.render();this.propsACatID&&this._prepareReferenceCategoryObj(!1);this.showDocAttributeCategory(!1,a)};b.prototype.resetDocument=function(){j.getInstance().resetDocDataByDocVerID(this.docVerID);this.dependsOnItself=!1;this.modDate=this.docDesc=this.thumbnailURL=this.docVerIdx=this.appStatus=this.docName=this.docID=this.docVerID="";this.appTypeList=[];this.userPerms={};this.project={};this.projects=[];this.docType=this.docTypeID=null;this.resetDocumentAttrCategory();
this.isChanged=!1};b.prototype.resetDocumentAttrCategory=function(){this.aCatID=null;this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};b.prototype.setIsChanged=function(){this.isChanged=!0;this.getParentDocTable()&&this.getParentDocTable().setIsChanged()};b.prototype.getIsChanged=function(){return this.isChanged};b.prototype.setStatus=function(a){this.isInErrorStatus()||(this.status=a,this.isInErrorStatus()&&(this.view.repaintRow(),this.hideDocAttributeCategory()))};b.prototype.isInErrorStatus=
function(){return"noperm"==this.status||"error"==this.status};b.prototype.getParentDocTable=function(){return this.parentDocTable};b.prototype.getIndexInTable=function(){return this.getParentDocTable()?this.getParentDocTable().docRows.indexOf(this):-1};b.prototype.getRowPrefix=function(){return this.prefix};b.prototype.getThisInDOM=function(){return this.getParentInDOM()+".getRowByID("+this.rowID+")"};b.prototype.getParentInDOM=function(){if(this.getParentDocTable())return this.getParentDocTable().getThisInDOM();
g.log("Error: Cannot find itself in parent documents table!");return"window"};b.prototype.findPropertyByID=function(a,b){b||(b=this.props);if(b)for(var c=0;c<b.length;c++){var f=b[c];if(f.id==a)return f}return null};b.prototype._updateDocInfo=function(a){var b=!1;if(a&&a.docVerID&&a.docVerID==this.docVerID){this.docID!=a.docID&&(b=!0,this.docID=a.docID);this.docName!=a.docName&&(b=!0,this.docName=a.docName);this.docDesc!=a.docDesc&&(b=!0,this.docDesc=a.docDesc);this.docVerIdx!=a.docVerIdx&&(b=!0,
this.docVerIdx=a.docVerIdx);this.latestDocVerIdx!=a.latestDocVerIdx&&(b=!0,this.latestDocVerIdx=a.latestDocVerIdx);this.docRevLetter!=a.docRevLetter&&(b=!0,this.docRevLetter=a.docRevLetter);this.appStatus!=a.appStatus&&(b=!0,this.appStatus=a.appStatus);this.thumbnailURL!=a.thumbnailURL&&(b=!0,this.thumbnailURL=a.thumbnailURL);this.docTypeID!=a.docTypeID&&(b=!0,this.docTypeID=a.docTypeID);!this.project.id&&(a.projList[0]&&this.project.id!=a.projList[0].id)&&(b=!0,this.project=a.projList[0]);a.projList&&
""+this.projects!=""+a.projList&&(b=!0,this.projects=a.projList);if(a.docVerAuthor&&(!this.docAuthor||this.docAuthor.id!=a.docVerAuthor.id))b=!0,this.docAuthor=a.docVerAuthor;if(this.modDate!=a.modDate)try{b=!0,this.modDate=a.modDate?new Date(parseInt(a.modDate)):""}catch(c){g.log("Failed to parse '"+a.modDate+"' to a Date object."),this.modDate=""}a.userPerms&&(this.userPerms=a.userPerms);a.appTypeList&&(this.appTypeList=a.appTypeList);a.docCheckedOutOwner&&(this.docCheckedOutOwner=a.docCheckedOutOwner)}else j.isEmptyValue(a)&&
this.setStatus("noperm");return b};b.prototype.updateDocInfoFromServer=function(a,b){this.setStatus("loading");if(!this.docVerID)return e.Deferred().reject("Cannot update document info from server, this.docVerID is not known!").promise();var c=j.getInstance().getDocInfoWithThumbnail(this.docVerID,b);c.done(function(b){this._updateDocInfo(b)&&a&&this.view.repaintRow()}.bind(this));c.fail(function(a){this.setStatus("error");g.log(a)}.bind(this));return c};b.prototype.isInConfigPreview=function(){return this.getParentDocTable().isInConfigPreview};
b.prototype.isRemoteDocument=function(){return this.project.id&&this.project.id!=this.getParentDocTable().projectID};b.prototype.isLatestDocVersion=function(){return this.latestDocVerIdx&&this.docVerIdx==this.latestDocVerIdx};b.prototype.hasAttrCat=function(){return!!this.aCatID&&!j.isEmptyValue(this.aCatID)&&g.isValidID(this.aCatID)};b.prototype.hasNoAttrCat=function(){return!!this.aCatID&&j.isEmptyValue(this.aCatID)};b.prototype.setDocumentHasNoAttrCategory=function(){this.aCatID=j.getEmptyValue();
this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};b.prototype.isAttrCatNeeded=function(){return g.getRenderItem(this.renderOptions.columns,"AttributeFlapout")||g.getRenderItem(this.renderOptions.columns,"DocumentAttribute")?!0:!1};b.prototype.isAttrCatUpdateNeeded=function(){return this.renderedAttrCat.id!=this.aCatID||this.renderedAttrCat.isEditable!=this.canUserEditExpandedAttributes()};b.prototype.canUserEditAttributes=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&
!this.dependsOnItself&&this.userPerms.change};b.prototype.canUserEditExpandedAttributes=function(){return this.canUserEditAttributes()&&this.isExpandedAttrsEditable};b.prototype.canUserEditProperties=function(){return!this.isInactive()&&this.isEditable&&!this.dependsOnItself};b.prototype.canUserAddDocuments=function(){return this.getParentDocTable().canUserAddDocuments};b.prototype.canUserUploadNewVersion=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&
this.isEditable&&this.userPerms.checkout};b.prototype.updateDocAttrCategoryFromServer=function(a){return!this.docVerID?null:j.getInstance().getDocAttrCatInfo(this.docVerID,a).pipe(function(a){var b=!1;a?a.id?(this.aCatID!=a.id&&(b=!0),this.aCatID=a.id):(j.isEmptyValue(this.aCatID)||(b=!0),this.setDocumentHasNoAttrCategory()):(j.isEmptyValue(this.aCatID)||(b=!0),this.setDocumentHasNoAttrCategory());return b}.bind(this),function(a){alert(a)})};b.prototype._initializeAndRenderAttrCategoryObj=function(a,
b){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.aCatElemID).length)if(this.hasAttrCat()){this.setStatus("loading");var c=h.getCloneOfObject(this.getParentDocTable().currentUser);c.canEditAttributes=this.canUserEditExpandedAttributes();var f=[],j=this.getParentDocTable().parentDocVerIDs;j&&0<j.length&&(f=h.getCloneOfArray(j));f.push(this.docVerID?this.docVerID:"newID_"+g.getNextUniquePrefix());var k={};k.prefix=this.aCatPrefix;k.ACatObj=this.aCatElemID;k.ACatPanel=this.aCatElemID;
k.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+this.aCatID+"&ajax=1";k.valuesURL=this.generateDocAttributeValuesAJAXURL();k.valuesURL||(k.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.aCatID+"&ajax=1");k.currentUser=c;k.view=this.getAttCatView();k.type="document";k.projectID=this.project.id;k.documentID=this.docID;this.docVerID&&(k.docVersionID=this.docVerID);a&&(k.callbackOnRender=a);b&&(k.callbackOnFail=b);k.docTableParentDocVerIDs=
f;k.isInactive=this.isInactive();k.aCatNotExpandedYet=this.aCatNotExpandedYet;this.renderOptions.styleObj&&(k.defaultStyleObject=this.renderOptions.styleObj.inlineStyleObject);require(["attributecategory/AttributeCategory"],function(a){this.aCatObj=new a(k);this.aCatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this));this.renderedAttrCat.id=this.aCatID;this.renderedAttrCat.isEditable=c.canEditAttributes}else g.log("Attempt to render attribute category when its ID is not known!")};
b.prototype._initializeAndRenderReferenceCategoryObj=function(a,b){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.propsACatElemID).length)if(this.propsACatID){this.setStatus("loading");this.propsValuesInitialized=!1;var c=h.getCloneOfObject(this.currentUser);c.canEditAttributes=this.canUserEditProperties();var f={};f.prefix=this.propsACatPrefix;f.ACatObj=this.propsACatElemID;f.ACatPanel=this.propsACatElemID;f.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+
this.propsACatID+"&ajax=1";f.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.propsACatID+"&ajax=1";f.currentUser=c;a&&(f.callbackOnRender=a);b&&(f.callbackOnFail=b);require(["attributecategory/AttributeCategory"],function(a){this.propsACatObj=new a(f);this.propsACatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this))}else g.log("Attempt to initialize reference properties when reference category ID is not known!")};b.prototype.generateDocAttributeValuesAJAXURL=
function(){var a=null;this.docVerID&&(a=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?docverid="+this.docVerID);return a};b.prototype.showDocAttributeCategory=function(a,b){this.aCatExpandDisabled&&(b=!1);if(this.docVerID&&!this.aCatID){var c=this.updateDocAttrCategoryFromServer();c&&(c.done(function(c){this._showDocAttributeCategory(a||c,b)}.bind(this)),c.fail(function(){this.hideDocAttributeCategory()}.bind(this)))}else this.hasAttrCat()?this._showDocAttributeCategory(a,b):this.hideDocAttributeCategory()};
b.prototype.getExpColButton=function(){return e("#"+this.getRowPrefix()+" > "+this.view.itemRootElemStr+" > a.expandCollapseButton > i")};b.prototype._expandDocAttrCat=function(b){b||(b=this.getExpColButton());this.dependsOnItself?b.removeClass("expand").addClass("cycle").attr("title",k.xmlencode(a.t("DocRowCyclicDepTooltip"))):b.removeClass("expand cycle").addClass("collapse").attr("title",k.xmlencode(a.t("DocRowCollapseTooltip")));e("#"+this.aCatRowID).removeClass("hiddenElement");this.aCatExpanded=
!0;this.aCatNotExpandedYet&&this.setACatIsExpanded()};b.prototype.setACatIsExpanded=function(){this.aCatNotExpandedYet=!1;this.aCatObj&&this.aCatObj.setACatIsExpanded();this.displayRow()};b.prototype._collapseDocAttrCat=function(b){b||(b=this.getExpColButton());this.dependsOnItself?b.removeClass("collapse").addClass("cycle").attr("title",k.xmlencode(a.t("DocRowCyclicDepTooltip"))):b.removeClass("collapse cycle").addClass("expand").attr("title",k.xmlencode(a.t("DocRowExpandTooltip")));e("#"+this.aCatRowID).addClass("hiddenElement");
this.aCatExpanded=!1};b.prototype._showDocAttributeCategory=function(a,b){if(a||this.isAttrCatUpdateNeeded())this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null;if(!this.hasAttrCat()||!this.isAttrCatNeeded())this.hideDocAttributeCategory();else{var c=this.getExpColButton();c.parent().removeClass("hiddenElement");if(this.dependsOnItself)this._collapseDocAttrCat(c);else if(b||this.aCatExpanded?this._expandDocAttrCat(c):this._collapseDocAttrCat(c),c=null!=g.getRenderItem(this.renderOptions.columns,
"DocumentAttribute"),!this.aCatNotExpandedYet||c)if(this.aCatObj){var c=!1,f=e("#"+this.aCatElemID);1==f.length&&f[0].ACatObj!=this.aCatObj&&(f[0].ACatObj=this.aCatObj,c=!0);c&&(this.aCatObj.isInactive=this.isInactive(),this.aCatObj.displayAttributeCategory())}else this._initializeAndRenderAttrCategoryObj(this._onAttrCategoryReady.bind(this,!1),this._onAttrCategoryLoadFailed.bind(this))}};b.prototype._prepareReferenceCategoryObj=function(a){this.propsACatID?(a&&(this.propsACatObj&&this.propsACatObj.destroy(),
this.propsACatObj=null),this.propsACatObj?(a=e("#"+this.propsACatElemID),1==a.length&&a[0].ACatObj!=this.propsACatObj&&(a[0].ACatObj=this.propsACatObj)):this._initializeAndRenderReferenceCategoryObj(this._onAttrCategoryReady.bind(this,!0),this._onAttrCategoryLoadFailed.bind(this))):g.log("StaticDocumentRow._prepareReferenceCategoryObj() called when no reference category ID known (or it was nullified)")};b.prototype._onAttrCategoryReady=function(a){if(a&&this.propsACatObj&&this.propsACatObj.loaded){if(!this.propsValuesInitialized){for(a=
0;a<this.props.length;a++){var b=this.props[a];if(b&&b.id){var c=this.propsACatObj.findAttribute(b.id,b.name);c&&c.copyValueFrom(b)}}this.propsValuesInitialized=!0}this.propsACatObj.destroy();e("#"+this.propsACatElemID).html("")}this.setStatus("ready");this.view.repaintRow()};b.prototype._onAttrCategoryLoadFailed=function(){this.setStatus("error");g.log("Failed to load attribute category.")};b.prototype.hideDocAttributeCategory=function(){var a=this.getExpColButton();this._collapseDocAttrCat(a);this.hasAttrCat()||
(a.parent().addClass("hiddenElement"),a=e("#"+this.aCatElemID),a.ACatObj&&a.ACatObj.destroy(),a.ACatObj=null,a.html(""))};b.prototype.collapseAllDescendants=function(){this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(a){a.collapseAllRows()},this);this._collapseDocAttrCat()};b.prototype.deleteItself=function(a){this.destroy();a?e("#"+this.view.phElemID).empty():e("#"+this.view.phElemID).remove();e("#"+this.aCatRowID).remove();this.view._newVersionRow.remove()};b.prototype.swapWith=function(a){this.aCatObj&&
this.aCatObj.beforeMove();e("#"+this.view.phElemID).insertAfter(e("#"+a.aCatRowID));this.view._newVersionRow?(this.view._newVersionRow.insertAfter(e("#"+this.view.phElemID)),e("#"+this.aCatRowID).insertAfter(this.view._newVersionRow)):e("#"+this.aCatRowID).insertAfter(e("#"+this.view.phElemID));this.view.repaintRow();a.view.repaintRow();this.aCatObj&&this.aCatObj.afterMove()};b.prototype.setDependsOnItself=function(a){this.dependsOnItself=!0==a};b.prototype.convertRefPropertiesToXML=function(){var a=
"";try{if(this.props&&0<this.props.length){for(var a=a+"<refatts>",b=0;b<this.props.length;b++){var c=this.props[b];c&&c.id&&(a+="<att>",a+=k.ElementEncode("id",c.id),a+="</att>")}a+="</refatts>";a+=k.ElementEncode("refprefix",this.propsACatPrefix)}}catch(f){g.log("Problem in StaticDocumentRow.convertRefPropertiesToXML:\n"+f),a=""}return a};b.prototype.convertUploadNewVersionToXML=function(){var a="";if(this.view.newVersionBtn&&this.view.newVersionBtn.isExpanded&&this.view._newVersionCell){var b=
this.view._newVersionCell,a=a+"<ds>"+k.ElementEncode("action","UploadNewVersion"),a=a+k.ElementEncode("file_form_field","newVersionDocFile_"+this.docVerID),a=a+k.ElementEncode("version_comment",b.find("input[name=newVersionDocDesc_"+this.docVerID+"]").val()),a=a+k.ElementEncode("raise_revision","checked"==b.find("input[name=incrementRevision_"+this.docVerID+"]").attr("checked")?"1":"0");0<e("input[name=AppCycleFlag"+this.docVerID+"]").length?(a+=k.ElementEncode("start_approval","checked"==b.find("input[name=AppCycleFlag"+
this.docVerID+"]").attr("checked")?"1":"0"),a+=k.ElementEncode("approval_due_date",b.find("input[name=due_date"+this.docVerID+"]").val()),a+=k.ElementEncode("approval_due_period",b.find("select[name=due_periodOfDay"+this.docVerID+"]").val())):a+=k.ElementEncode("start_approval",b.find("input[name=startApprovalDefaultValue"+this.docVerID+"]").val());a+="</ds>"}return a};b.prototype.convertToXML=function(a){var b="";try{b+="<dr>",this.drID&&(b+=k.ElementEncode("id",this.drID)),a&&0<a.length&&(b+=a),
this.docVerID&&(b+=k.ElementEncode("dv",this.docVerID),this.docVerIdx&&(b+=k.ElementEncode("dvidx",this.docVerIdx)),this.docID&&(b+=k.ElementEncode("doc_id",this.docID)),this.docName&&(b+=k.ElementEncode("dn",this.docName))),this.appStatus&&this.appStatus.cycleStatus&&(b+=k.ElementEncode("astat",this.appStatus.cycleStatus)),this.isEditable&&(b+=this.convertUploadNewVersionToXML(),b+=this.convertRefPropertiesToXML()),this.isInErrorStatus()||(b+=k.ElementEncode("daprefix",this.aCatPrefix)),b+="</dr>"}catch(c){g.log("Problem in StaticDocumentRow.convertToXML:\n"+
c),b=""}return b};b.prototype.validateDocRow=function(b,c){var i=!0;if(this.isInactive())return i;if(this.aCatObj&&this.aCatObj.loaded){var f=[];if(this.canUserEditAttributes()&&!b.isTemplate){var g=this.renderOptions.columns;if(g)for(var h=0;h<g.length;h++){var k=g[h];if(k&&k.type&&"DocumentAttribute"==k.type){var j=k.typeDetail;f.push(j);if("Required"==k.visibility&&(k=this.aCatObj.findAttribute(j,k.attributeName))&&!k.value)i={level:c,attrLabel:this.aCatObj.getAttributeLabel(k),element:e("#"+this.aCatObj.prefix+
k.id).closest("td").find("*"),docRowObj:this},b.errors.push(i),i=!1}}}this.aCatObj.validateAttributes(!1,b,f,this,c+1)||(i=!1)}if(this.canUserEditProperties()&&!b.isTemplate&&this.props&&this.propsACatObj&&this.propsACatObj.loaded)for(h=0;h<this.props.length;h++)if((f=this.props[h])&&f.id&&f.isRequired)if((g=this.propsACatObj.findAttribute(f.id,f.name))&&!g.value)i={level:c,msg:a.t("DocRowPropertyRequiredButNull",f.name),element:e("#"+this.propsACatObj.prefix+g.id).closest("td").find("*"),docRowObj:this},
b.errors.push(i),i=!1;if(this.view.newVersionBtn&&(f=this.view.newVersionBtn.validate())&&0<f.length){for(h=0;h<f.length;h++)i=f[h],i.level=c,i.docRowObj=this,b.errors.push(i);i=!1}return i};b.prototype.expandBranchTillThis=function(a){for(var b=this.getRowPrefix().split("_"),c=1,f=0,g="";f+2<b.length&&c<a;){var h=b[f]+"_"+b[++f],k=g+h+"_docTable",j=b[++f],k=e("#"+k);if(1==k.length&&(k=k[0].docTable))(k=k.getRowByID(j))&&k.showDocAttributeCategory(!1,!0);g+=h+"_"+j+"_ACat_";f+=2;c++}};b.prototype._onSubmit=
function(){this.aCatObj&&!this.isInactive()&&this.aCatObj.convertDocReferencesToXML()};b.prototype.expandClicked=function(a){a&&(a=e(a).find("i"),a.hasClass("cycle")||(a.hasClass("expand")?this.showDocAttributeCategory(!1,!0):this.hideDocAttributeCategory()))};b.prototype.destroy=function(){this.destroyACatObj()};b.prototype.destroyACatObj=function(){this.aCatObj&&this.aCatObj.destroy()};b.prototype.reconstruct=function(){this.aCatObj&&this.aCatObj.reconstruct()};b.prototype.getAttCatView=function(){return this.aCatView||
"Default"};return b});
define("doctablex/DocumentRowView",["doctablex/StaticDocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,a){var h=function(a,c,b){if(!a&&!c&&!b)return this;g.call(this,a,c,b);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocTemplateSelector=function(){var g="";try{var e=this.dm.docTemplates;if(!e||0==e.length)return g;if("FixedDocTemplate"==this.dm.docTempType)g+="<span>"+a.xmlencode(j.t("PROJ_CREATION_DOCUMENT_TEMPLATE"))+
":&nbsp;</span>",g+="<span>"+a.xmlencode(e[0].name)+"</span>";else{g='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+".docTemplateSelected(this.value);")+'">';g+='<option value="-1"'+(!this.dm.selDocTemplate?' selected="selected"':"")+">"+a.xmlencode(j.t("SELECTDOCTEMPLATE"))+"...</option>";if(e)for(var b=0;b<e.length;b++)var d=e[b],g=g+('<option value="'+b+'"'+(this.dm.selDocTemplate==d?' selected="selected"':"")+">"+a.xmlencode(d.name)+
"</option>");g+="</select>"}}catch(l){c.log("Problem in DocumentRowView.renderDocTemplateSelector:\n"+l),g=""}return g};h.prototype.renderDocFolderSelector=function(){var g="";try{var e=this.dm.targetFolders;if(!e||0==e.length)return g;if(1==e.length){var b=e[0].name;"0"==e[0].id&&(b=j.t("DEFAULT_FOLDER_ROOT"));g+="<label>"+a.xmlencode(j.t("FOLDER"))+":&nbsp;"+a.xmlencode(b)+"</label>"}else{var g='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+
".targetFolderSelected(this.value);")+'">',d=e[0].id;this.dm.selTargetFolder&&(d=this.dm.selTargetFolder.id);b=!1;this.dm.selDocTemplate&&(this.dm.selTargetFolder.isDefaultFromDocTempl&&(b=!0),g+='<option value="-1"'+(b?' selected="selected"':"")+">",g+=a.xmlencode(j.t("DEFAULT_FOLDER_TEMPLATE")),g+="</option>");for(var l=0;l<e.length;l++)var i=e[l],g=g+('<option value="'+l+'"'+(d==i.id&&!b?' selected="selected"':"")+">"),g="0"==i.id?g+a.xmlencode(j.t("DEFAULT_FOLDER_ROOT")):g+a.xmlencode(i.name),
g=g+"</option>";g+="</select>"}}catch(f){c.log("Problem in DocumentRowView.renderDocFolderSelector:\n"+f),g=""}return g};h.prototype.showAdvancedDocumentActions=function(){return!1};return h});
define("utils/EventBasedValidator",["utils/webi18n!validatorStrings","jquery","utils/WCEvent"],function(g,c,j){return{getInstance:function(){window.eventBasedValidator||(window.eventBasedValidator={onValidateUniqueDocName:function(a){j.on("validation.uniqueDocName",a)},createUniqueNamesObj:function(){return{errors:[],newDocs:[],newDocsDOMElems:{},excludedProjects:{},localClashFound:!1,addDoc:function(a,c){if(a.val()){var j=a.val().toLowerCase();this.newDocsDOMElems[c+"_"+j]?(this.newDocsDOMElems[c+
"_"+j].push(a[0]),this.localClashFound||(j={msg:g.t("PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES"),element:this.newDocsDOMElems[this.projectID+"_"+j],docRowObj:this},this.errors.splice(0,0,j),this.localClashFound=!0)):(this.newDocsDOMElems[c+"_"+j]=a,c&&!this.excludedProjects[c]&&this.newDocs.push({docName:j,projectId:c}))}},excludeProject:function(a){this.excludedProjects[a]=!0},isOk:function(){return 0==this.errors.length}}},validateNamesGlobally:function(a){a||(a=this.createUniqueNamesObj());j.emit("validation.uniqueDocName",
a);0<a.newDocs.length&&c.ajax({url:"GetDocumentsByNameAndProjectID.jsp",dataType:"json",method:"POST",async:!1,data:{data:JSON.stringify({docs:a.newDocs})}}).done(function(b){if(b.docs&&0<b.docs.length)for(var d=0;d<b.docs.length;d++){var c={msg:g.t("NAMECONFLICTEXCEPTION_ADV_TAG",b.docs[d].docName,b.docs[d].projectName),element:a.newDocsDOMElems[b.docs[d].projectId+"_"+b.docs[d].docName.toLowerCase()]};a.errors.push(c)}});for(var h="",k=0;k<a.errors.length;k++){var e=a.errors[k];e.msg&&(h+=e.msg+
"\n");e.element&&e.element.addClass("validationHighlight")}h&&alert(h)}});return window.eventBasedValidator}}});
define("doctablex/DocumentRow","doctablex/StaticDocumentRow doctablex/DocumentRowView doctablex/DocTableXUtils wcr/webcenter_xml utils/EventBasedValidator utils/webi18n!DocRefStrings underscore".split(" "),function(g,c,j,a,h,k,e){var b=function(a){if(!a)return this;a.viewClass||(a.viewClass=c);g.call(this,a);this.docOperation=a.operation||null;this.useDocTypeDefaultACat=!1;this.origDocRow=a.origDocRow||null;this.docVerIdx="1";this.docRevLetter="";this.latestDocVerIdx="1";this.fieldsModByUser=[];this.docNameSuffix=
null;this.anPrefix=a.anPrefix||null;this.anSuffix=a.anSuffix||null;this.anCounterLength=a.anCounterLength||0;this.docTempType=a.docTempType;this.docTempType||(this.docTempType="AnyDocTemplate");this.docTempNames=a.docTempNames||"";this.selDocTemplate=this.docTemplates=null;this.targetFolderName=a.targetFolderName||"";this.selTargetFolder=this.targetFolders=null;this.constructor==b.prototype.constructor&&this.setStatus("ready");h.getInstance().onValidateUniqueDocName(e.bind(function(a){this.validateDocRowUniqueName(a)},
this));return this};b.prototype=new g;b.prototype.constructor=b;b.prototype.parent=g.prototype;b.prototype.resetDocument=function(a){this.anSuffix=this.anPrefix=null;this.anCounterLength=0;a&&(b.prototype.parent.resetDocument.call(this),this.fieldsModByUser=[])};b.prototype.canUserEditAttributes=function(){var a=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&a};b.prototype.generateDocAttributeValuesAJAXURL=function(){var a=
window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&j.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):j.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:j.log("Cannot generate URL in DocumentRowNew.generateDocAttributeValuesAJAXURL().");return a};
b.prototype.isModifiedByUser=function(a){return-1<this.fieldsModByUser.indexOf(a)};b.prototype.setFieldModByUser=function(a,b){if(b){var c=this.fieldsModByUser.indexOf(a);-1<c&&this.fieldsModByUser.splice(c,1)}else this.fieldsModByUser.push(a)};b.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length};b.prototype.hasAutonameSuffix=function(){return this.anSuffix&&-1<this.anSuffix.toLowerCase().indexOf("[editfield]")};b.prototype.updateDocumentType=function(a,b){var c=
a.docTypeList;if(c&&this.docTypeID)for(var f=0;f<c.length;f++){var e=c[f];if(this.docTypeID==e.id){this.docType=e;this.anPrefix=e.anPrefix;this.anSuffix=e.anSuffix;this.anCounterLength=e.anCounterLength;this.selDocTemplate&&(this.aCatID=this.selDocTemplate.categoryID);!this.hasAttrCat()&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID);b&&(this.view.repaintRow(),this.showDocAttributeCategory(!1,!0));break}}};b.prototype.updateDocTemplates=function(a){this.docTemplates=[];if(a&&!(0==
a.length||this.isInConfigPreview()))if(!this.docTempType||"AnyDocTemplate"==this.docTempType)this.docTemplates=a;else if("NoDocTemplate"!=this.docTempType)if("FixedDocTemplate"==this.docTempType){var b=this.docTempNames[0];if(b){for(var c=0;c<a.length;c++){var f=a[c];if(f&&f.name&&f.name.toLowerCase()==b){this.docTemplates.push(f);break}}1==this.docTemplates.length&&this.updateDocTemplateSelection(0)}}else if("ListDocTemplate"==this.docTempType)for(c=0;c<a.length;c++)(f=a[c])&&(f.name&&0<=this.docTempNames.indexOf(f.name.toLowerCase()))&&
this.docTemplates.push(f)};b.prototype.preselectDocTemplate=function(){if(!this.docTempType||!("NoDocTemplate"==this.docTempType||"FixedDocTemplate"==this.docTempType)){var a=this.origFileExt;a||(a=this.fileExt);a=this._matchDocTemplate("default."+a);0>a&&(a=this._matchDocTemplate("default"));this.updateDocTemplateSelection(a)}};b.prototype._matchDocTemplate=function(a){if(this.docTemplates)for(var b=0;b<this.docTemplates.length;b++)if(this.docTemplates[b].name.toLowerCase()==a)return b;return-1};
b.prototype.updateDocTemplateSelection=function(a){var b=this.aCatID;-1==a?(this.selDocTemplate=null,this.docType&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID)):this.docTemplates&&(0<=a&&a<this.docTemplates.length)&&(this.selDocTemplate=a=this.docTemplates[a],this.aCatID=a.categoryID,!this.hasAttrCat()&&(this.docType&&this.useDocTypeDefaultACat)&&(this.aCatID=this.docType.categoryID));this.aCatID!=b&&(this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null);this.preselectTargetFolder()};
b.prototype.updateTargetFolders=function(a){a&&0<a.length&&!this.isInConfigPreview()?this.targetFolders=a:(this.targetFolders=[],this.selTargetFolder=null)};b.prototype.preselectTargetFolder=function(){if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else if(!this.isModifiedByUser("targetFolder")){var a=this._findTargetFolderByName(this.targetFolderName);this.setSelectedTargetFolder(a,!a)}};b.prototype._findTargetFolderByName=function(a){if(this.targetFolders&&a)for(var a=
a.toLowerCase(),b=0;b<this.targetFolders.length;b++){var c=this.targetFolders[b];if(c&&c.name.toLowerCase()==a)return c}return null};b.prototype.setSelectedTargetFolder=function(a,b){this.selTargetFolder&&(this.selTargetFolder.isDefaultFromDocTempl=!1);if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else{if(b){if(this.selDocTemplate&&(this.selTargetFolder=this._findTargetFolderByName(this.selDocTemplate.folderName)))this.selTargetFolder.isDefaultFromDocTempl=!0}else this.selTargetFolder=
a;this.selTargetFolder||(this.selTargetFolder=this.targetFolders[0],b&&(this.selTargetFolder.isDefaultFromDocTempl=!0))}};b.prototype.convertToXML=function(b){var c="";try{if(this.isInErrorStatus())return c;c+="<dr>";this.origDocRow?(this.origDocRow.drID&&(c+=a.ElementEncode("id",this.origDocRow.drID)),this.origDocRow.docVerID&&(c+=a.ElementEncode("dv",this.origDocRow.docVerID))):this.drID&&(c+=a.ElementEncode("id",this.drID));b&&0<b.length&&(c+=b);c+=this.convertRefPropertiesToXML();this.canUserEditAttributes()&&
(c+=a.ElementEncode("daprefix",this.aCatPrefix));c+="</dr>"}catch(e){j.log("Problem in StaticDocumentRow.convertToXML:\n"+e),c=""}return c};b.prototype.validateDocRow=function(a,c){var e=!0,f=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");1==f.length&&(!f.val()&&!this.isAutonamingEnabled())&&(e={isBlocking:!0,level:c,msg:k.t("DocRowDocNameRequired"),element:f,docRowObj:this},a.errors.push(e),e=!1);b.prototype.parent.validateDocRow.call(this,a,c)||(e=!1);return e};b.prototype.validateDocRowUniqueName=
function(a){if(!this.isAutonamingEnabled()&&this.isEditable&&!this.isInactive()){var b=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");a.addDoc(b,this.project.id)}};b.prototype.docNameChanged=function(a){this.docName!=a&&(this.docName=a,this.setIsChanged(),this.setFieldModByUser("docName",!a))};b.prototype.docNameSuffixChanged=function(a){this.docNameSuffix!=a&&(this.docNameSuffix=a,this.setIsChanged(),this.setFieldModByUser("docNameSuffix",!a))};b.prototype.docDescChanged=function(a){this.docDesc!=
a&&(this.docDesc=a,this.setIsChanged(),this.setFieldModByUser("docDescription",!a))};b.prototype.docTemplateSelected=function(a){this.setIsChanged();this.setFieldModByUser("docTemplate",-1==a);this.resetDocumentAttrCategory();this.updateDocTemplateSelection(a);this.view.repaintRow();this.showDocAttributeCategory(!1,!0)};b.prototype.targetFolderSelected=function(a){this.setIsChanged();this.setFieldModByUser("targetFolder",-1==a);-1==a?this.setSelectedTargetFolder(null,!0):this.setSelectedTargetFolder(this.targetFolders[a]);
this.showDocAttributeCategory(!1,!1)};return b});
define("doctablex/DocumentRowSearchView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,a){var h=function(a,c,b){if(!a&&!c&&!b)return this;g.call(this,a,c,b);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocumentSpec=function(g){try{var e="",b="Copy"==this.dm.docOperation,d="Move"==this.dm.docOperation,h="Link"==this.dm.docOperation,e=e+("<"+this.itemRootElemStr+">"),
e=e+'<div class="form-docref">',e=this.dm.origDocRow?e+('<span class="form-label">'+a.xmlencode(j.t("DocRowLocalRemoteMakeLocal"))+":</span>"):e+('<span class="form-label">'+a.xmlencode(this.dm.dlsName)+" ("+a.xmlencode(this.dm.docOperation)+"):</span>"),e=e+('<span class="form-inline-field">'+a.xmlencode(this.dm.selDocName)+"</span>"),e=e+'<div class="DocumentNameRow">';if(b||d)if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var i="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",
f=this.dm.docNameSuffix?this.dm.docNameSuffix:"",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),e=e+('" maxlength="250" size="40" onchange="'+i+'" value="'+a.xmlencode(f)+'"/>');else e+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName")),e+='" maxlength="250" size="40" disabled="disabled"/>';else var n=this.dm.docName?this.dm.docName:"",m="javascript: "+this.dm.getThisInDOM()+
".docNameChanged(this.value);",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),e=e+('" maxlength="250" size="40" onchange="'+m+'" value="'+a.xmlencode(n)+'"/>');var o="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",p=this.dm.docDesc?this.dm.docDesc:"";b?e+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+
o+'" value="'+a.xmlencode(p)+'"/>':0<p.length&&(d||(e+='<div class="DocumentDescriptionRow">'),e+="<span>"+a.xmlencode(j.t("DocRowDocumentDescription"))+":</span>",e+='<span class="form-inline-field-indent">'+a.xmlencode(p)+"</span>",d||(e+="</div>"));e+="</div>";if(b||d||h)e+='<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class=DocumentTemplateAndFolderRow">',b&&(e+=this.renderDocTemplateSelector()),e+=this.renderDocFolderSelector(),e+="</div>";e+="</div>";e+="</"+this.itemRootElemStr+">";
g.append(e)}catch(r){c.log("Problem in DocumentRowSearchView.renderDocumentSpec:\n"+r)}};h.prototype.renderLocalRemoteButton=function(g){try{var e="",e=e+("<"+this.itemRootElemStr+' class="center">');if(this.dm.origDocRow)var b="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+");",d=a.xmlencode(j.t("DocRowLocalRemoteResetButtonTooltip")),e=e+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/round_button_reset.png"'),e=e+(' title="'+d+'" onclick="'+
b+'"/>');e+="</"+this.itemRootElemStr+">";g.append(e)}catch(h){c.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+h)}};return h});
define("doctablex/DocumentRowSearch","doctablex/DocumentRow doctablex/DocTableXUtils doctablex/DocumentRowSearchView doctablex/AJAXDataCache wcr/webcenter_xml jquery".split(" "),function(g,c,j,a,h,k){var e=function(a){if(!a)return this;a.viewClass||(a.viewClass=j);g.call(this,a);this.dlsName=a.dlsName||"Search";this.docOperation||(this.docOperation="Copy");if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.fileExt=c.getFileExtension(this.docName,!0);this.selDocName=
this.docName;this.hasOrigDocACat=!1;this.constructor==e.prototype.constructor&&this._initializeFromServer();return this};e.prototype=new g;e.prototype.constructor=e;e.prototype.parent=g.prototype;e.prototype._initializeFromServer=function(){this.setStatus("loading");var b=this.updateDocInfoFromServer(!1);b.done(function(){this.docDesc="";"Copy"==this.docOperation&&(this.docVerIdx="1",this.docRevLetter="");var b=a.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),c=null,e=null;"Copy"==
this.docOperation&&(c=a.getInstance().getDocTemplatesByProjID(this.project.id));var f=null;"Reference"!=this.docOperation&&(f=a.getInstance().getFoldersByProjID(this.project.id));e=this.updateDocAttrCategoryFromServer();k.when(b,c,f,e).done(function(a,b,c){this.useDocTypeDefaultACat=this.hasNoAttrCat()&&"Copy"==this.docOperation;this.hasOrigDocACat=this.hasAttrCat();this.updateDocumentType(a,!1);b&&(this.updateDocTemplates(b),this.preselectDocTemplate());this.updateTargetFolders(c);this.preselectTargetFolder();
this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to load document configuration from the server.\n"+a)}.bind(this))}.bind(this));b.fail(function(a){this.setStatus("error");c.log("Failed to process basic info about document loaded from the server.\n"+a)}.bind(this))};e.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length&&"Copy"==this.docOperation};e.prototype.canUserEditAttributes=
function(){var a=!1,a=this.userPerms?this.userPerms.change:!1,c=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1,a="Reference"==this.docOperation?a:"Link"==this.docOperation?a||c:c;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};e.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&c.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+
("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):this.hasOrigDocACat&&this.docVerID?a+="GetAttributes.jsp?docverid="+this.docVerID:c.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:c.log("Cannot generate URL in DocumentRowSearch.generateDocAttributeValuesAJAXURL().");return a};e.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus())return a;
var d="<ds>",d=d+h.ElementEncode("action",this.docOperation);this.docVerID&&(d+=h.ElementEncode("source_dv_id",this.docVerID));this.project.id&&(d+=h.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(d+=h.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?d+=h.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(d+=h.ElementEncode("doc_name",this.docName));this.docDesc&&(d+=h.ElementEncode("doc_description",
this.docDesc));this.hasAttrCat()&&(d+=h.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(d+=h.ElementEncode("doc_temp_id",this.selDocTemplate.id),d+=h.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));a=e.prototype.parent.convertToXML.call(this,d+"</ds>")}catch(g){c.log("Problem in DocumentRowSearch.convertToXML:\n"+g),a=""}return a};e.prototype.getAttCatView=function(){var a=!1,d=c.getRenderItem(this.renderOptions.columns,"AttributeFlapout");d&&!1===d.useCreationView&&
(a=!0);return!a&&"Copy"==this.docOperation?"Creation":this.aCatView||"Default"};return e});
define("doctablex/DocumentRowBrowseView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,a){var h=function(a,c,b){if(!a&&!c&&!b)return this;g.call(this,a,c,b);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.render=function(a){var e=c.preserveFileInputs(this.phElemID);h.prototype.parent.render.call(this,a);0<e&&c.reinsertPreservedFileInputs(this.dm.fileInputName)};h.prototype.renderThumbnail=
function(a,e){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),b=b+("</"+this.itemRootElemStr+">");a.append(b)}catch(d){c.log("Problem in DocumentRowBrowseView.renderThumbnail:\n"+d)}};h.prototype.renderDocumentSpec=function(g){try{var e=this.dm.fileInputName,b="",b=b+("<"+this.itemRootElemStr+">"),b=b+'<div class="form-docref">',b=b+('<label for="'+e+'" class="form-label">'+this.dm.dlsName+":</label>"),d="javascript: "+this.dm.getThisInDOM()+
".fileChanged(this);",b=b+('<input type="file" name="'+e+'" size="30" onchange="'+d+'"/>'),b=b+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var h="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",i=this.dm.docNameSuffix?this.dm.docNameSuffix:"",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),b=b+('" maxlength="250" size="40" onchange="'+h+'" value="'+
i+'"/>');else b+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName")),b+='" maxlength="250" size="40" disabled="disabled"/>';else var f="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",n=this.dm.docName?this.dm.docName:"",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),b=b+('" maxlength="250" size="40" onchange="'+f+'" value="'+n+'"/>');var m="javascript: "+
this.dm.getThisInDOM()+".docDescChanged(this.value);",o=this.dm.docDesc?this.dm.docDesc:"",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+m+'" value="'+o+'"/>'),b=b+"</div>",b=b+('<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class="DocumentTemplateAndFolderRow">'),b=b+this.renderDocTemplateSelector(),b=b+this.renderDocFolderSelector(),b=b+"</div>",b=b+("</"+this.itemRootElemStr+
">");g.append(b)}catch(p){c.log("Problem in DocumentRowBrowseView.renderDocumentSpec:\n"+p)}};return h});
define("doctablex/DocumentRowBrowse","doctablex/DocumentRow doctablex/DocumentRowBrowseView doctablex/AJAXDataCache doctablex/DocTableXUtils doctablex/DocumentTypeUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,a,h,k,e,b){var d=function(a){if(!a)return this;a.viewClass||(a.viewClass=c);g.call(this,a);this.isValidFileSelected=!1;this.fileInputName=this.getRowPrefix()+"_fileForm";this.dlsName=a.dlsName||"Upload";this.docOperation="Upload";this.allowedFileExts=a.allowedFileExts||
[];this.origFileExt=null;this.project={id:this.getParentDocTable().projectID};this.useDocTypeDefaultACat=!0;this.constructor==d.prototype.constructor&&this._initializeFromServer();return this};d.prototype=new g;d.prototype.constructor=d;d.prototype.parent=g.prototype;d.prototype._initializeFromServer=function(){if(!this.docTemplates&&this.project.id){this.setStatus("loading");var a=j.getInstance().getDocTemplatesByProjID(this.project.id),c=j.getInstance().getFoldersByProjID(this.project.id);b.when(a,
c).done(function(a,b){this.updateDocTemplates(a);this.preselectDocTemplate();this.updateTargetFolders(b);this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Problem with retrieving document templates:\n"+a)}.bind(this))}else this.docTemplates?this.setStatus("ready"):this.setStatus("error")};d.prototype.getIsValidFileSelected=function(){return this.isValidFileSelected};d.prototype.resetDocument=
function(a){this.isValidFileSelected=!1;b(a).removeClass("docTableFileInputToPreserve");this.docType=this.docTypeID=null;d.prototype.parent.resetDocument.call(this,!1)};d.prototype.convertToXML=function(){var b="";try{if(this.isInErrorStatus()||!this.getIsValidFileSelected())return b;var c="<ds>",c=c+e.ElementEncode("action",this.docOperation);this.fileInputName&&(c+=e.ElementEncode("file_form_field",this.fileInputName));this.project.id&&(c+=e.ElementEncode("project_id",this.project.id));this.selTargetFolder&&
(c+=e.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?c+=e.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(c+=e.ElementEncode("doc_name",this.docName));this.docDesc&&(c+=e.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(c+=e.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(c+=e.ElementEncode("doc_temp_id",this.selDocTemplate.id),c+=e.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));
b=d.prototype.parent.convertToXML.call(this,c+"</ds>")}catch(f){a.log("Problem in DocumentRow.convertToXML:\n"+f),b=""}return b};d.prototype.validateDocRow=function(a,c){var f=!0,e=b("input[name="+this.fileInputName+"]");1==e.length&&!e.val()&&(f={isBlocking:!0,level:c,msg:k.t("DocRowFileNotChosen"),element:e,docRowObj:this},a.errors.push(f),f=!1);d.prototype.parent.validateDocRow.call(this,a,c)||(f=!1);return f};d.prototype.fileChanged=function(c){if(this.isInConfigPreview())alert(k.t("DocSrcHdlNoProjectInConfig"));
else{this.setStatus("loading");var d=c.value;d&&(this.resetDocument(c),-1!=d.lastIndexOf("\\")?d=d.substring(d.lastIndexOf("\\")+1):-1!=d.lastIndexOf("/")?d=d.substring(d.lastIndexOf("/")+1):-1!=d.lastIndexOf(":")&&(d=d.substring(d.lastIndexOf(":")+1)),this.origFileExt=a.getFileExtension(d,!0),this.allowedFileExts&&0<this.allowedFileExts.length&&-1==this.allowedFileExts.indexOf(this.origFileExt)?(alert(k.t("notAllowedDocExtension")+this.allowedFileExts.toString()),this.view.repaintRow()):(this.docName=
d,this.setIsChanged(),b(c).addClass("docTableFileInputToPreserve"),this.isValidFileSelected=!0,d=j.getInstance(),c=d.getEffectiveDocTypesSettingsByProjID(this.project.id),d=d.getDocTemplatesByProjID(this.project.id),b.when(c,d).done(function(a,b){this.docTypeID=h.getDocTypeIDByExtension(this.origFileExt);this.updateDocumentType(a,!1);this.updateDocTemplates(b);this.isModifiedByUser("docTemplate")||this.preselectDocTemplate();this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();
this.showDocAttributeCategory(!1,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to process document configuration from the server.\n"+a)}.bind(this))))}};d.prototype.getAttCatView=function(){var b=a.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return b&&!1===b.useCreationView?this.aCatView||"Default":"Creation"};return d});
define("doctablex/DocumentRowNewView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml","jquery"],function(g,c,j,a,h){var k=function(a,b,c){if(!a&&!b&&!c)return this;g.call(this,a,b,c);return this};k.prototype=new g;k.prototype.constructor=k;k.prototype.parent=g.prototype;k.prototype.getDocTemplateDialogPlaceholder=function(){var c=h("#"+this.dm.docTempDialogPHID);0==c.length&&(c=h('<div id="'+this.dm.docTempDialogPHID+'"></div>').appendTo("body"),
c.attr("style","display: none; background-color: #F7F7F7; border-collapse: collapse; border-bottom: 1px solid #dfdfdf;"),c.attr("title",a.xmlencode(j.t("SELECTDOCTEMPLATE"))));return c};k.prototype.renderDocTemplateDialog=function(){var c=h("#"+this.dm.docTempDialogPHID);if(!this.dm.docTemplates||0==this.dm.docTemplates.length||1!=c.length)return null;h("#docTemplateDialogFilter").off();h(".docTemplatesList").off();c.empty();var b=h('<div class="docTemplatesFilterRow darktext_darklink_11"></div>'),
d="<span>"+a.xmlencode(j.t("PROJDETAILSTOTALDOCS_TAG"))+": "+this.dm.docTemplates.length+"</span>",d=d+('<span class="form-inline-field-indent">'+a.xmlencode(j.t("FILTER"))+":</span>");b.html(d+'<input class="form-field-small form-inline-field-indent" id="docTemplateDialogFilter" name="docTemplateDialogFilter"/>');b.find("#docTemplateDialogFilter").on("keyup",function(){var a=h(this).val().toLowerCase();0<a.length?h("div.docTemplateRow").each(function(b,c){-1!=h(c).find("div.docTemplateName").text().toLowerCase().indexOf(a)?
h(c).show():h(c).hide()}):h("div.docTemplateRow").show()});c.append(b);b=h('<div class="docTemplatesList" style="overflow: auto; height: 350px; background-color: #FFFFFF;"></div>');b.on("click",function(a){h('input[name="docTemplateSelectOption"]:checked').attr("checked",!1);a.target.checked=!0});for(var d="",g=0;g<this.dm.docTemplates.length;g++){var i=this.dm.docTemplates[g],d=d+'<div class="docTemplateRow">',d=d+('<input type="radio" value="'+g+'" name="docTemplateSelectOption"');0==g&&(d+=" checked");
d+="/>";d+='<img class="form-inline-field-indent" src="'+i.thumbnailURL+'" width="50" height="50" border="0" align="middle">';d+='<div class="docTemplateName form-inline-field-indent">'+a.xmlencode(i.name)+"</div>";d+="</div>"}b.html(d);c.append(b);h("#popitmenu").css("z-index",1200);return c};k.prototype.renderDocumentSpec=function(e){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+'<div class="form-docref">',b=b+('<span class="form-label">'+a.xmlencode(this.dm.dlsName)+":</span>"),b=b+('<span class="form-inline-field">'+
a.xmlencode(this.dm.selDocTemplate.name)+"</span>"),b=b+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var d="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",g=this.dm.docNameSuffix?this.dm.docNameSuffix:"",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),b=b+('" maxlength="250" size="40" onchange="'+d+'" value="'+a.xmlencode(g)+'"/>');else b+='<input type="text" class="form-control form-field-medium" placeholder="'+
a.xmlencode(j.t("DocRowDocumentName")),b+='" maxlength="250" size="40" disabled="disabled"/>';else var i=this.dm.docName?this.dm.docName:"",f="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),b=b+('" maxlength="250" size="40" onchange="'+f+'" value="'+a.xmlencode(i)+'"/>');var h="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",k=this.dm.docDesc?
this.dm.docDesc:"",b=b+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+h+'" value="'+a.xmlencode(k)+'"/>'),b=b+"</div>",b=b+('<div id="'+(this.phElemID+"_folderSelPHID")+'" class="FolderRow">'),b=b+this.renderDocFolderSelector(),b=b+"</div>",b=b+"</div>",b=b+("</"+this.itemRootElemStr+">");e.append(b)}catch(o){c.log("Problem in DocumentRowNewView.renderDocumentSpec:\n"+o)}};return k});
define("doctablex/DocumentRowNew","doctablex/DocumentRow doctablex/DocumentRowNewView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,a,h,k,e){var b=function(a){if(!a)return this;a.viewClass||(a.viewClass=c);g.call(this,a);this.dlsName=a.dlsName||"New";this.docOperation="New";if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.docTempDialogPHID=a.docTempDialogPHID;this.docTempDialogPHID||
(this.docTempDialogPHID="docTemplateDialogPHID");this.isDocTempDialogInitialized=!1;this.constructor==b.prototype.constructor&&this._initializeFromServer();return this};b.prototype=new g;b.prototype.constructor=b;b.prototype.parent=g.prototype;b.prototype._initializeFromServer=function(){this.setStatus("loading");var a=j.getInstance().getDocTemplatesByProjID(this.project.id,!0),b=j.getInstance().getFoldersByProjID(this.project.id);e.when(a,b).done(function(a,b){this.updateDocTemplates(a);this.updateTargetFolders(b);
this.showDocTemplateDialog()}.bind(this)).fail(function(a){this.isInConfigPreview()?alert(h.t("DocSrcHdlNoDocTempInConfig")):(this.setStatus("error"),alert("Failed to load document templates from the server.\n"+a))}.bind(this))};b.prototype.showDocTemplateDialog=function(){if(this.docTemplates)if(0==this.docTemplates.length)alert(h.t("DocSrcHdlNoDocTempComplyFilter"));else if(1==this.docTemplates.length)this.updateDocTemplateSelection(0),this.preselectTargetFolder(),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0);else{var a=this.view.getDocTemplateDialogPlaceholder();if(!this.isDocTempDialogInitialized){var b={};b[h.t("CANCEL")]=function(){a.dialog("close")}.bind(this);b[h.t("OK")]=function(){this.setStatus("loading");var b=e('input[name="docTemplateSelectOption"]:checked:visible');0==b.length?alert(h.t("SELECTDOCTEMPLATE")+"."):(this.updateDocTemplateSelection(b.val()),this.preselectTargetFolder(),a.dialog("close"),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0))}.bind(this);a.dialog({autoOpen:!1,modal:!1,draggable:!0,resizable:!0,overflow:scroll,width:500,buttons:b});null!=this.view.renderDocTemplateDialog()&&(this.isDocTempDialogInitialized=!0)}a.dialog("open");this.setStatus("wait4user")}};b.prototype.updateDocTemplateSelection=function(a){b.prototype.parent.updateDocTemplateSelection.call(this,a);this.selDocTemplate&&(this.docName=this.selDocTemplate.name,this.thumbnailURL=this.selDocTemplate.thumbnailURL,
this.docTypeID=this.selDocTemplate.docTypeID);var a=j.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),c="resolved"==a.state();a.done(function(a){this.updateDocumentType(a,!c)}.bind(this));a.fail(function(a){alert("Failed to load document templates from the server.\n"+a)})};b.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus())return c;var e="<ds>",e=e+k.ElementEncode("action",this.docOperation),e=e+k.ElementEncode("template_dv_id",this.selDocTemplate.docVerID);
this.project.id&&(e+=k.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(e+=k.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?e+=k.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(e+=k.ElementEncode("doc_name",this.docName));this.docDesc&&(e+=k.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(e+=k.ElementEncode("doc_attr_cat_id",this.aCatID));e+=k.ElementEncode("doc_temp_id",this.selDocTemplate.id);
e+=k.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName);c=b.prototype.parent.convertToXML.call(this,e+"</ds>")}catch(g){a.log("Problem in DocumentRowNew.convertToXML:\n"+g),c=""}return c};b.prototype.getAttCatView=function(){var b=a.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return b&&!1===b.useCreationView?this.aCatView||"Default":"Creation"};return b});
define("doctablex/DocumentRowLinkView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(g,c,j,a){var h=function(a,c,b){if(!a&&!c&&!b)return this;g.call(this,a,c,b);return this};h.prototype=new g;h.prototype.constructor=h;h.prototype.parent=g.prototype;h.prototype.renderDocumentSpec=function(g,e){try{var b="",b=b+("<"+this.itemRootElemStr+">"),b=b+this.renderInlineLabel(e);if(this.dm.isInErrorStatus())b=this.dm.isInConfigPreview()?
b+("<span>"+j.t("DocSrcHdlNoProjectInConfig")+"</span>"):b+("<span>"+j.t("DocRowLoadingDocsError")+"</span>");else{b+='<div class="form-docref">';b+='<div class="DocumentNameRow">';if(this.dm.docsInCurrentProject)if(0==this.dm.docsInCurrentProject.length)b+="<span>"+j.t("DocRowNoDocsAvailable")+"</span>";else{for(var d="javascript: "+this.dm.getThisInDOM()+".docVersionSelected(this.value);",b=b+('<select class="form-control form-field-medium form-dropdown-field" onChange="'+d+'">'),b=b+('<option value="">'+
a.xmlencode(j.t("DocRowPleaseSelect"))+"</option>"),d=0;d<this.dm.docsInCurrentProject.length;d++)var h=this.dm.docsInCurrentProject[d].id,i=this.dm.docsInCurrentProject[d].name,b=b+('<option value="'+h+'"'+(this.dm.docVerID==h?' selected="selected"':"")+">"),b=b+(a.xmlencode(i)+"</option>");b+="</select>"}else b+="<span>"+j.t("DocRowLoadingDocs")+"</span>";b+="</div>";b+="</div>"}b+="</"+this.itemRootElemStr+">";g.append(b)}catch(f){c.log("Problem in DocumentRowLinkView.renderDocumentSpec:\n"+f)}};
h.prototype.renderThumbnail=function(a,e){try{if(this.dm.docVerID)h.prototype.parent.renderThumbnail.call(this,a,e);else{var b="<"+this.itemRootElemStr+">",b=b+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),b=b+("</"+this.itemRootElemStr+">");a.append(b)}}catch(d){c.log("Problem in DocumentRowLinkView.renderThumbnail:\n"+d)}};return h});
define("doctablex/DocumentRowLink","doctablex/DocumentRow doctablex/DocumentRowLinkView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(g,c,j,a,h,k,e){var b=function(a){if(!a)return this;a.viewClass||(a.viewClass=c);g.call(this,a);this.dlsName=a.dlsName||"Link";this.docOperation="Reference";this.project={id:this.getParentDocTable().projectID};this.docsInCurrentProject=null;this.constructor==b.prototype.constructor&&this._initializeFromServer();
return this};b.prototype=new g;b.prototype.constructor=b;b.prototype.parent=g.prototype;b.prototype._initializeFromServer=function(){if(this.project.id){this.setStatus("loading");var a=j.getInstance().getDocVersionsByProjID(this.project.id);a.done(function(a){this.initDocsInCurrentProject(a);this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this));a.fail(function(a){this.setStatus("error");alert(h.t("DocRowLoadingDocsError")+":\n"+a)}.bind(this))}else this.setStatus("error")};
b.prototype.resetDocument=function(){b.prototype.parent.resetDocument.call(this,!0)};b.prototype.initDocsInCurrentProject=function(a){this.docsInCurrentProject=!a||0==a.length?[]:a};b.prototype.canUserEditAttributes=function(){var a=this.userPerms?this.userPerms.change:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};b.prototype.generateDocAttributeValuesAJAXURL=function(){return b.prototype.parent.parent.generateDocAttributeValuesAJAXURL.call(this)};
b.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus()||!this.docVerID)return c;var e="<ds>",e=e+k.ElementEncode("action",this.docOperation);this.docVerID&&(e+=k.ElementEncode("source_dv_id",this.docVerID));c=b.prototype.parent.convertToXML.call(this,e+"</ds>")}catch(g){a.log("Problem in DocumentRowLink.convertToXML:\n"+g),c=""}return c};b.prototype.validateDocRow=function(a,c){var g=!0,f=e("#"+this.getRowPrefix()+" div.DocumentNameRow > select:first");1==f.length&&!f.val()&&(g=
{isBlocking:!0,level:c,msg:h.t("DocRowDocNotSelected"),element:f,docRowObj:this},a.errors.push(g),g=!1);b.prototype.parent.validateDocRow.call(this,a,c)||(g=!1);return g};b.prototype.docVersionSelected=function(b){this.docVerID!=b&&(this.resetDocument(),this.setStatus("loading"),this.docVerID=b,this.getParentDocTable().isDocDependentOnItself(this)&&(confirm(h.t("DocRowDocDependentOnItself"))?this.setDependsOnItself(!0):this.docVerID=""),""==this.docVerID?(this.setStatus("ready"),this.view.repaintRow(),
this.hideDocAttributeCategory()):(b=this.updateDocInfoFromServer(!1),b.done(function(){this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)),b.fail(function(b){this.setStatus("error");a.error("Failed to load document information from the server:\n"+b)})))};return b});
define("doctablex/DocTableX","wcr/webcenter_xml doctablex/DocTableXView doctablex/DocTableXUtils doctablex/AJAXDataCache doctablex/DocumentRowSearch doctablex/DocumentRowBrowse doctablex/DocumentRowNew doctablex/DocumentRowLink utils/webi18n!DocRefStrings jquery wcr/search wcr/extpopup".split(" "),function(g,c,j,a,h,k,e,b,d,l){var i=function(a){if(!a)return this;this.isInConfigPreview=a.isInConfigPreview||!1;this.currentUser=a.currentUser||null;this.onChangeCallback=a.onChangeCallback||null;this.docRows=
[];this.isChanged=!1;this.parentDocVerIDs=a.parentDocVerIDs||[];this.phElemID=a.phElemID;this.saveXMLRootTag="dtval";a.saveXMLRootTag&&(this.saveXMLRootTag=g.xmlencode(a.saveXMLRootTag));this.thisInDOM="document.getElementById('"+this.phElemID+"').docTable";this.greenLinksPrefix;this._setPrefix(a.prefix);this.dshObj=a.dshObj;if(!this.dshObj)return alert("Document table cannot be created without DocumentSourceHandler reference!"),null;this.isEditable=a.isEditable||!1;this.currentUser&&!1==this.currentUser.canEditAttributes&&
(this.isEditable=!1);this.isInactive=a.isInactive||!1;this.parentACatNotExpandedYet=a.parentACatNotExpandedYet||!1;this.clearValues=a.clearValues||!1;this.allowMultiple=a.allowMultiple||!1;this.projectID=a.projectID||null;this.canUserAddDocuments=this.hasDocumentTemplates=this.isInConfigPreview;this.aCatView=a.aCatView;var b={renderMethod:"list",showGreenLinksOnTop:!0,showGreenLinksAtBottom:!1};this.renderOptions=a.renderOptions||b;this.propsACatID=a.propsACatID||null;null==j.getRenderItem(this.renderOptions.columns,
"ReferenceProperty")&&(this.propsACatID=null);this.constructor==i.prototype.constructor&&(this.view=new c(this,this.phElemID,this.renderOptions),this._initializeFromServer());return this};i.prototype._initializeFromServer=function(){if(!this.isInConfigPreview)if(this.projectID){var b=a.getInstance().getDocTemplatesByProjID(this.projectID,!0),c=a.getInstance().getFoldersByProjID(this.projectID);l.when(b,c).done(function(a,b){var c=this.hasDocumentTemplates,d=this.canUserAddDocuments;this.hasDocumentTemplates=
a&&0<a.length;this.canUserAddDocuments=b&&0<b.length;if(this.hasDocumentTemplates!=c||this.canUserAddDocuments!=d)this.view.renderDocSourceLinks(),this.canUserAddDocuments!=d&&this.view.repaintRemoteDocRows()}.bind(this)).fail(function(a){alert("Failed to load data needed to initialize DocTableX instance from the server.\n"+a)})}else j.log("DocTableX._initializeFromServer(): There is no project ID to load configuration for.")};i.prototype.setIsChanged=function(){if(this.onChangeCallback)this.onChangeCallback();
this.isChanged=!0};i.prototype.getIsChanged=function(){if(this.isChanged)return!0;for(var a=0;a<this.docRows.length;a++){var b=this.docRows[a];if(b&&b.getIsChanged())return!0}return!1};i.prototype._setPrefix=function(a){a||(a="");this.prefix=a;this.greenLinksPrefix=a+"_greenLinks"};i.prototype.getTablePrefix=function(){return this.prefix};i.prototype.getThisInDOM=function(){return this.thisInDOM};i.prototype.getRowByID=function(a){for(var b=0;b<this.docRows.length;b++){var c=this.docRows[b];if(c.rowID==
a)return c}return null};i.prototype.getDocumentSourceOptions=function(a){return{docTable:this,hasDocumentTemplates:this.hasDocumentTemplates,canUserAddDocuments:this.canUserAddDocuments,linksId:a}};i.prototype.hasLocalRemoteButton=function(){return null!=j.getRenderItem(this.renderOptions.columns,"LocalRemote")};i.prototype.reset=function(){this.docRows=[];this.parentDocVerIDs=[];this.isChanged=!1};i.prototype.setCustomView=function(a,b){a&&(a.dm=this,a.phElemID||(a.phElemID=this.phElemID),a.renderOptions||
(a.renderOptions=this.renderOptions),this.view=a,b&&this.displayTable())};i.prototype.setIsEditable=function(a,b){if(void 0!==a&&a!=this.isEditable){this.isEditable=a;for(var c=0;c<this.docRows.length;c++)this.docRows[c].setIsEditable(a)}b&&this.displayTable()};i.prototype.setIsInactive=function(a){void 0!==a&&a!=this.isInactive&&(this.isInactive=a)};i.prototype.hasSameContentAs=function(a){if(this.docRows&&!a||!this.docRows&&a||this.docRows&&this.docRows.length!=a.length)return!1;for(var b=0;b<this.docRows.length;b++){var c=
this.docRows[b],d=a[b];if(c&&!d||!c&&d||c&&c.docVerID!=d.docVerID)return!1;var e=c.props?c.props:[];if(e.length!=(d.props?d.props:[]).length)return!1;for(var g=0;g<e.length;g++){var h=e[g];if(h&&h.id){var i=d.findPropertyByID(h.id);if(!i)return!1;if(c.propsACatObj&&c.propsACatObj.loaded){if((h=c.propsACatObj.findAttribute(h.id,h.name))&&h.value!=i.value)return!1}else if(h.value!=i.value)return!1}}}return!0};i.prototype.initWithDocRows=function(a,b){if(!a)return!1;for(var c=0;c<a.length;c++){var d=
a[c];if(d){if(this!==d.getParentDocTable())return!1;this.isDocDependentOnItself(d)&&d.setDependsOnItself(!0);this.docRows.push(d)}}b&&this.displayTable();return!0};i.prototype._insertRow=function(a,b,c){this.isDocDependentOnItself(a)&&a.setDependsOnItself(!0);if(this.allowMoreToAdd())null!=b&&b<this.getNumberOfRows()?(0>b&&(b=0),this.docRows.splice(b,0,a)):this.docRows.push(a);else if(confirm(d.t("DocTableReplaceSingleValueQ")))this.docRows[this.getNumberOfRows()-1]=a;else return!1;c&&this.displayTable();
return!0};i.prototype.appendDocRow=function(a,b,c){a.parentDocTable=this;a=new b(a);return this._insertRow(a,null,c)};i.prototype.addDocRow=function(a,b,c,e,g){a.parentDocTable=this;a=new b(a);if(e&&this.isDocDependentOnItself(a)&&!confirm(d.t("DocTableCycleDependencyWarning")))return!1;g||(g=0);return this._insertRow(a,g,c)};i.prototype.addDocRows=function(a,b,c){for(var d=!1,e=0;e<a.length;e++)this.addDocRow(a[e],b,e==a.length-1,c,e)&&(d=!0);d&&c&&this.setIsChanged()};i.prototype.addSearchDocRows=
function(a,b){this.addDocRows(a,h,b)};i.prototype.addBrowseRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,allowedFileExts:j._getFileExtensionsList(a.documentType),docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};this.addDocRow(a,k,!0,!0)&&this.setIsChanged()};i.prototype.addLinkRow=function(a){a={parentDocTable:this,dlsName:a.dlsObj.label.getLabel()};this.addDocRow(a,b,!0,!0)&&this.setIsChanged()};
i.prototype.addDocTemplateRow=function(a){a&&this._insertRow(a,0,!0)&&this.setIsChanged()};i.prototype.openDocTemplateDialog=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};new e(a)};i.prototype.getDocTemplateNameList=function(a){return j._getDocTemplateNameList(a)};i.prototype.isDocDependentOnItself=function(a){var b=this.parentDocVerIDs;return a.docVerID&&
b&&-1!=b.indexOf(a.docVerID)};i.prototype.getNumberOfRows=function(){return this.docRows.length};i.prototype.allowMoreToAdd=function(){return this.allowMultiple||1>this.getNumberOfRows()};i.prototype.displayTable=function(){var a=this.view.render();a&&1==a.length&&(a[0].docTable=this)};i.prototype.convertToXML=function(){var a="";try{a+="<"+this.saveXMLRootTag+">";this.isEditable||(a+=g.ElementEncode("readonly","1"));for(var b=0;b<this.docRows.length;b++)a+=this.docRows[b].convertToXML();a+="</"+
this.saveXMLRootTag+">"}catch(c){j.log("Problem in DocTableX.convertToXML:\n"+c),a=""}return a};i.prototype.validateDocTable=function(a,b){if(!this.isInactive)for(var c=0;c<this.docRows.length;c++)this.docRows[c].validateDocRow(a,b)};i.prototype.onSubmit=function(){this.clearValues&&(this.docRows=[]);if(!this.isInactive||this.clearValues){var a=this.getTablePrefix(),a=l("#"+a);0<a.length&&a.val(this.convertToXML())}if(!this.isInactive)for(a=0;a<this.docRows.length;a++)this.docRows[a]._onSubmit()};
i.prototype.localRemoteButtonClicked=function(a){if(!(0>a)){var b=this.docRows[a];b.deleteItself(!0);b.origDocRow?this.docRows[a]=b.origDocRow:(b={parentDocTable:this,docVerID:b.docVerID,docID:b.docID,docName:b.docName,dlsName:d.t("DocRowMakeLocalAction"),targetFolderName:b.targetFolderName,projectID:this.projectID,operation:"Copy",docTempType:b.docTempType,docTempNames:b.docTempNames,properties:b.props,origDocRow:b},this.docRows[a]=new h(b));this.docRows[a].displayRow()}};i.prototype.deleteButtonClicked=
function(a){if(!(0>a))if(this.docRows[a].deleteItself(),this.docRows.splice(a,1),this.setIsChanged(),0<this.getNumberOfRows())for(a=0>a-1?0:a-1;a<this.getNumberOfRows();a++)this.docRows[a].view.repaintRow();else this.displayTable()};i.prototype.moveUpButtonClicked=function(a){if(0<a){var b=this.docRows[a-1];this.docRows[a-1]=this.docRows[a];this.docRows[a]=b;this.docRows[a].swapWith(this.docRows[a-1]);this.setIsChanged()}};i.prototype.moveDownButtonClicked=function(a){if(a<this.getNumberOfRows()-
1){var b=this.docRows[a+1];this.docRows[a+1]=this.docRows[a];this.docRows[a]=b;this.docRows[a+1].swapWith(this.docRows[a]);this.setIsChanged()}};i.prototype.expandCollapseAllClicked=function(a){a=l(a);a.hasClass("expandAll")?this.expandAllRows():a.hasClass("collapseAll")&&this.collapseAllRows()};i.prototype.expandAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].showDocAttributeCategory(!1,!0)};i.prototype.collapseAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].collapseAllDescendants()};
i.prototype.destroy=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].destroy()};i.prototype.reconstruct=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].reconstruct()};return i});